#!/usr/bin/perl
# Copyright (c) 2012 Mariusz Dziewulski <pronext@pronext.com.pl>. All rights reserved.
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.

# This software use procedure "insert()" and related functions created by
# Author:  (c) Soren Dossing, 2005
# License: OSI Artistic License
#          http://www.opensource.org/licenses/artistic-license.php



# Please change this parameters
# Configuration=================================================================

my $rootpath="/raid0/apps/cmwatch_server";
#chomp($rootpath);
my $traffic_file = "/tmp/traffic";  #path to locate traffic files
my $community="batius474";          #read only community for read parameters from cable modems via snmp
my $community_cmts='dcva11mz';      #read only community for read parameters from CMTS
my $ip_cmts='192.168.77.153';       #IP address of CMTS
my $rrddir=$rootpath.'/rrd';        #path to locate rrd files 

#================================================================================

my $mapfile=$rootpath.'/map_rrd.conf';
my $heartbeat=86400;
my $debug=0;
my $logfile=$rootpath.'/graph.log';
my $iface_speed=8;
my $pingtimeout=0.1;

my ($r1,$out_bytes_mta,$r2,$r3,$err,$in_bytes_mta,$err_cor,$err_ncor,$err_stat,$cm_stat,$in_bytes_eth,$out_bytes_usb,$in_bytes_usb,$out_bytes_eth,$in_bytes,$out_bytes,$in_bytes_rf,$out_bytes_rf,$lost_rtp,$out_rtp,$in_rtp) = 0;
my @lines;

use Net::Ping;
use Net::SNMP;
use RRDs;

open(FILE_IP, "<",$rootpath."/check_cm_modem_ip.dat") or die $!;
while(<FILE_IP>)
{
    s/#.*//;            # ignore comments by erasing them
    next if /^(\s)*$/;  # skip blank lines
    chomp;
    push @lines, $_;
}
close FILE_IP;
my @ips=keys %{{ map{$_=>1}@lines}};  #remove duplicates

foreach(@ips)
{
        $ip=$_;
        $p = Net::Ping->new();
        if ($p->ping($ip,$pingtimeout))
    	{
            $p->close();
	    $time=time();
	    $timestart=$time-10;
	    $update_time=$time;
	    $mta=0;
	    ( $session, $error ) = Net::SNMP->session(-hostname  => $ip, -community => $community, -timeout=>2);                                                                                                                                                                                                                                                                                        
	    $response = $session->get_request('1.3.6.1.2.1.2.2.1.1.16'); 
	    $mta      = $response->{'1.3.6.1.2.1.2.2.1.1.16'};

	    $response = $session->get_request('1.3.6.1.2.1.2.2.1.6.2'); 
	    $hfc_mac  = $response->{'1.3.6.1.2.1.2.2.1.6.2'};

            $ups_rx_power=0;
            $ups_sn=0;
            ( $session_cmts, $error_cmts ) = Net::SNMP->session(-hostname  => $ip_cmts, -community => $community_cmts, -timeout=>1);
            ($nic,$nic,$mac1,$mac2,$mac3,$mac4,$mac5,$mac6,$mac7,$mac8,$mac9,$mac10,$mac11,$mac12)=split(//,$hfc_mac);
            $dec_hfc_mac=hex($mac1.$mac2).'.'.hex($mac3.$mac4).'.'.hex($mac5.$mac6).'.'.hex($mac7.$mac8).'.'.hex($mac9.$mac10).'.'.hex($mac11.$mac12);
            $response= $session_cmts->get_request("1.3.6.1.2.1.10.127.1.3.7.1.2.".$dec_hfc_mac);
            $cm_sid=   $response->{"1.3.6.1.2.1.10.127.1.3.7.1.2.".$dec_hfc_mac};
            $response= $session_cmts->get_request("1.3.6.1.2.1.10.127.1.3.3.1.6.".$cm_sid);
            $ups_rx_power=$response->{"1.3.6.1.2.1.10.127.1.3.3.1.6.".$cm_sid};
            $response= $session_cmts->get_request("1.3.6.1.2.1.10.127.1.3.3.1.13.".$cm_sid);
            $ups_sn=   $response->{"1.3.6.1.2.1.10.127.1.3.3.1.13.".$cm_sid};
            if($ups_rx_power=="") {$ups_rx_power=0;}
            if($ups_sn=="")       {$ups_sn=0;}

	    $response = $session->get_request('1.3.6.1.2.1.2.2.1.10.5'); 
	    $usb      = $response->{'1.3.6.1.2.1.2.2.1.10.5'};
	    if ( !($usb == "") )
	    {
		push( @snmpoids, '1.3.6.1.2.1.2.2.1.10.5');
		push( @snmpoids, '1.3.6.1.2.1.2.2.1.16.5');
	    }	
		
	    $response = $session->get_request(@snmpoids);
	    $response=$session->get_request('1.3.6.1.2.1.2.2.1.10.3'); 
	    $in_bytes_rf   = $response->{'1.3.6.1.2.1.2.2.1.10.3'};
	    $response=$session->get_request('1.3.6.1.2.1.2.2.1.16.4');
	    $out_bytes_rf  = $response->{'1.3.6.1.2.1.2.2.1.16.4'};
	    $response=$session->get_request('1.3.6.1.2.1.2.2.1.10.1');
	    $in_bytes_eth  = $response->{'1.3.6.1.2.1.2.2.1.10.1'};
	    $response=$session->get_request('1.3.6.1.2.1.2.2.1.16.1');
	    $out_bytes_eth = $response->{'1.3.6.1.2.1.2.2.1.16.1'};
	    if ( !($usb == "") )
	    {
		$response=$session->get_request('1.3.6.1.2.1.2.2.1.10.5');
		$in_bytes_usb  = $response->{'1.3.6.1.2.1.2.2.1.10.5'};
		$response=$session->get_request('1.3.6.1.2.1.2.2.1.16.5');
		$out_bytes_usb = $response->{'1.3.6.1.2.1.2.2.1.16.5'};			
	    }		

	    $response=$session->get_request('1.3.6.1.2.1.1.1.0');
	    $sysDesc            = $response->{'1.3.6.1.2.1.1.1.0'}; #sysDesc

	    $response=$session->get_request('1.3.6.1.2.1.10.127.1.1.1.1.6.3');
	    $r1            = $response->{'1.3.6.1.2.1.10.127.1.1.1.1.6.3'}; #Downstream power
            $response=$session->get_request('1.3.6.1.2.1.10.127.1.1.1.1.2.3'); #downstream_frequency
            $down_fr       = $response->{'1.3.6.1.2.1.10.127.1.1.1.1.2.3'}; #downstream_frequency
	    $response=$session->get_request('1.3.6.1.2.1.10.127.1.2.2.1.3.2');
	    $r2            = $response->{'1.3.6.1.2.1.10.127.1.2.2.1.3.2'}; #Upstream power
	    $response=$session->get_request('1.3.6.1.2.1.10.127.1.1.4.1.5.3');
	    $r3            = $response->{'1.3.6.1.2.1.10.127.1.1.4.1.5.3'}; #sn
	    $response=$session->get_request('1.3.6.1.2.1.10.127.1.1.4.1.2.3');
	    $err           = $response->{'1.3.6.1.2.1.10.127.1.1.4.1.2.3'}; #bledy
	    $response=$session->get_request('1.3.6.1.2.1.10.127.1.1.4.1.3.3');
	    $err_cor       = $response->{'1.3.6.1.2.1.10.127.1.1.4.1.3.3'}; #bledy skorygowane
	    $response=$session->get_request('1.3.6.1.2.1.10.127.1.1.4.1.4.3');
	    $err_ncor      = $response->{'1.3.6.1.2.1.10.127.1.1.4.1.4.3'}; #bledy nieskorygowane
	    $response=$session->get_request('1.3.6.1.2.1.10.127.1.1.1.1.1.3');
	    $n_chanel_id   = $response->{'1.3.6.1.2.1.10.127.1.1.1.1.1.3'};
	    $response=$session->get_request('1.3.6.1.2.1.10.127.1.1.2.1.1.4');
	    $n_upstream_id = $response->{'1.3.6.1.2.1.10.127.1.1.2.1.1.4'};
            $response=$session->get_request('1.3.6.1.2.1.10.127.1.1.2.1.2.4'); #upstream frequency
            $up_fr         = $response->{'1.3.6.1.2.1.10.127.1.1.2.1.2.4'};
	
	    $upstream_id   = $n_upstream_id-1;
	
	    if ($err == ""){$err=0;}
	    if ($err_cor == ""){$err_cor=0;}
	    if ($err_ncor == ""){$err_ncor=0;}
	    $in_bytes_mta=0;
	    $out_bytes_mta=0;
	    if ( $mta == 16 )
	    {
		$response=$session->get_request('1.3.6.1.2.1.2.2.1.10.16');
		$in_bytes_mta  = $response->{'1.3.6.1.2.1.2.2.1.10.16'};
		$response=$session->get_request('1.3.6.1.2.1.2.2.1.16.16');
		$out_bytes_mta = $response->{'1.3.6.1.2.1.2.2.1.16.16'};
		$response=$session->get_request('1.3.6.1.4.1.4115.1.3.3.1.1.1.2.3.0');
        	$lost_rtp      = $response->{'1.3.6.1.4.1.4115.1.3.3.1.1.1.2.3.0'}; #lost                                                                    
        	$response=$session->get_request('1.3.6.1.4.1.4115.1.3.3.1.1.1.2.1.0');
		$out_rtp       = $response->{'1.3.6.1.4.1.4115.1.3.3.1.1.1.2.1.0'}; #tx                                                                      
		$response=$session->get_request('1.3.6.1.4.1.4115.1.3.3.1.1.1.2.2.0');
		$in_rtp        = $response->{'1.3.6.1.4.1.4115.1.3.3.1.1.1.2.2.0'};	    
	    }			
	    my $row;
	    my @last_values;
	    my $last_check_time=$time-1;
	    my $last_in_bytes=$in_bytes_rf;;
	    my $last_out_bytes=$out_bytes_rf;
	    my $last_in_bytes_eth=$in_bytes_eth;;
	    my $last_out_bytes_eth=$out_bytes_eth;
	    my $last_in_bytes_usb=$in_bytes_usb;
	    my $last_out_bytes_usb=$out_bytes_usb;
	    my $last_in_bytes_mta=$in_bytes_mta;
	    my $last_out_bytes_mta=$out_bytes_mta;
	    my $last_bytes_err=$bytes_err;
	    my $last_bytes_err_cor=$bytes_err_cor;
	    my $last_bytes_err_ncor=$bytes_err_ncor;
	    my $last_out_rtp=$out_rtp;
	    my $last_in_rtp=$in_rtp;

	    if(open(FILE,"<".$traffic_file."_if4"."_".$ip)) 
	    {
		while($row = <FILE>)
		{
 		    @last_values = split(":",$row);
 		    $last_check_time = $last_values[0];
 		    $last_in_bytes = $last_values[1];
 		    $last_out_bytes = $last_values[2];
 		    $last_in_bytes_eth = $last_values[3];
 		    $last_out_bytes_eth = $last_values[4];
 		    $last_in_bytes_usb = $last_values[5];
 		    $last_out_bytes_usb = $last_values[6];
 		    $last_bytes_err = $last_values[7];	
 		    $last_bytes_err_cor = $last_values[8];
 		    $last_bytes_err_ncor = $last_values[9];
		    if ( $mta == 16 )
		    {
 			$last_in_bytes_mta = $last_values[10];
			$last_out_bytes_mta = $last_values[11];
			$last_out_rtp = $last_value[12];
			$last_in_rtp  = $last_value[13];
		    }    
		}
		close(FILE);
	    }

	    open(FILE,">".$traffic_file."_if4"."_".$ip) or die "Can't open $traffic_file for writing: $!";
	    print FILE "$update_time:$in_bytes_rf:$out_bytes_rf:$in_bytes_eth:$out_bytes_eth:$in_bytes_usb:$out_bytes_usb:$err:$err_cor:$err_ncor:$in_bytes_mta:$out_bytes_mta:$out_rtp:$in_rtp";
	    close(FILE);

	    if($last_in_bytes>$in_bytes_rf){ $last_in_bytes=$in_bytes_rf ;}
	    if($last_out_bytes>$out_bytes_rf){ $last_out_bytes=$out_bytes_rf;}
	    $in_traffic_rf = sprintf("%.2f",($in_bytes_rf-$last_in_bytes)/(time-$last_check_time));
	    $out_traffic_rf = sprintf("%.2f",($out_bytes_rf-$last_out_bytes)/(time-$last_check_time));
	    $inUsage_rf = sprintf("%.1f",($in_traffic_rf*100)/$iface_speed);
	    $outUsage_rf = sprintf("%.1f",($out_traffic_rf*100)/$iface_speed);

	    if($last_in_bytes_eth>$in_bytes_eth){$last_in_bytes_eth=$in_bytes_eth ;}
	    if($last_out_bytes_eth>$out_bytes_eth){$last_out_bytes_eth=$out_bytes_eth;}
	    $in_traffic_eth = sprintf("%.2f",($in_bytes_eth-$last_in_bytes_eth)/(time-$last_check_time));
	    $out_traffic_eth = sprintf("%.2f",($out_bytes_eth-$last_out_bytes_eth)/(time-$last_check_time));
	    $inUsage_eth = sprintf("%.1f",($in_traffic_eth*100)/$iface_speed);
	    $outUsage_eth = sprintf("%.1f",($out_traffic_eth*100)/$iface_speed);

	    if($last_in_bytes_usb>$in_bytes_usb){$last_in_bytes_usb=$in_bytes_usb ;}
	    if($last_out_bytes_usb>$out_bytes_usb){$last_out_bytes_usb=$out_bytes_usb;}
	    $in_traffic_usb = sprintf("%.2f",($in_bytes_usb-$last_in_bytes_usb)/(time-$last_check_time));
	    $out_traffic_usb = sprintf("%.2f",($out_bytes_usb-$last_out_bytes_usb)/(time-$last_check_time));
	    $inUsage_usb = sprintf("%.1f",($in_traffic_usb*100)/$iface_speed);
	    $outUsage_usb = sprintf("%.1f",($out_traffic_usb*100)/$iface_speed);

	    if($last_bytes_err>$bytes_err){$last_bytes_err=$bytes_err ;}
	    $traffic_err = sprintf("%.2f",($bytes_err-$last_bytes_err)/(time-$last_check_time));
	    $inUsage_err = sprintf("%.1f",($traffic_err));
	    if($last_bytes_err_cor>$bytes_err_cor){$last_bytes_err_cor=$bytes_err_cor ;}
	    $traffic_err_cor = sprintf("%.2f",($bytes_err_cor-$last_bytes_err_cor)/(time-$last_check_time));
	    $inUsage_err_cor = sprintf("%.1f",($traffic_err_cor));
	    if($last_bytes_err_ncor>$bytes_err_ncor){$last_bytes_err_ncor=$bytes_err_ncor ;}
	    $traffic_err_ncor = sprintf("%.2f",($bytes_err_ncor-$last_bytes_err_ncor)/(time-$last_check_time));
	    $inUsage_err_ncor = sprintf("%.1f",($traffic_err_ncor));
	
	    if($last_in_bytes_mta>$in_bytes_mta) {$last_in_bytes_mta=$in_bytes_mta ;}
	    $in_traffic_mta = sprintf("%.2f",($in_bytes_mta-$last_in_bytes_mta)/(time-$last_check_time));
	    $inUsage_mta = sprintf("%.1f",($in_traffic_mta*100)/$iface_speed);
	    if($last_out_bytes_mta>$out_bytes_mta) {$last_out_bytes_mta=$out_bytes_mta;}
	    $out_traffic_mta = sprintf("%.2f",($out_bytes_mta-$last_out_bytes_mta)/(time-$last_check_time));
	    $outUsage_mta = sprintf("%.1f",($out_traffic_mta*100)/$iface_speed);

	    if($last_in_rtp>$in_rtp) {$last_in_rtp=$in_rtp ;}
	    $in_traffic_rtp = sprintf("%.2f",($in_rtp-$last_in_rtp)/(time-$last_check_time));
	    $inUsage_rtp = sprintf("%.1f",($in_traffic_rtp*100)/$iface_speed);
	    if($last_out_rtp>$out_rtp) {$last_out_rtp=$out_rtp;}
	    $out_traffic_mta = sprintf("%.2f",($out_rtp-$last_out_rtp)/(time-$last_check_time));
	    $outUsage_rtp = sprintf("%.1f",($out_traffic_mta*100)/$iface_speed);

    	    if ($inUsage_eth ==  '') {$inUsage_eth=0};
	    if ($outUsage_eth == '') {$outUsage_eth=0};
	    if ($inUsage_usb ==  '') {$inUsage_usb=0};
	    if ($outUsage_usb == '') {$outUsage_usb=0};
	    if ($inUsage_mta ==  '') {$inUsage_mta=0};
	    if ($outUsage_mta == '') {$outUsage_mta=0};
	    if ($inUsage_rtp ==  '') {$inUsage_rtp=0};
	    if ($outUsage_rtp == '') {$outUsage_rtp=0};

	    if ($in_bytes_mta == '')  {$in_bytes_mta=0};
	    if ($out_bytes_mta == '') {$out_bytes_mta=0};
	    if ($lost_rtp == '')      {$lost_rtp=0};
	    if ($out_rtp == '')       {$out_rtp=0};
	    if ($in_rtp == '')        {$in_rtp=0};
	
	    if ($r1 == '') {$r1=0};
	    if ($r2 == '') {$r2=0};
	    if ($r3 == '') {$r3=0};

	    $SERVICEDESC="CM";
	    $SERVICEOUTPUT="OK";
	    $SERVICEPERFDATA="inusage_eth=$inUsage_eth outusage_eth=$outUsage_eth inusage_usb=$inUsage_usb outusage_usb=$outUsage_usb downpower=$r1 uppower=$r2 sn=$r3 inusage_mta=$inUsage_mta outusage_mta=$outUsage_mta in_rtp=$inUsage_rtp out_rtp=$outUsage_rtp lost_rtp=$lost_rtp ups_rx_power=$ups_rx_power ups_sn=$ups_sn";
	    $dane="$time||$ip||$SERVICEDESC||$SERVICEOUTPUT||$SERVICEPERFDATA";
	    
	    print "=============================================================================\n";
	    print "Cable modem: ".$ip;	    
	    print "\n";
	    print "System description: ".$sysDesc;
	    print "\n";	    
	    $r1=$r1/10;
	    $r2=$r2/10;
	    $r3=$r3/10;
	    print "Downstream power: ".$r1." dBmV";
	    print "\n";	    
	    print "Upstream power:   ".$r2." dBmV";
	    print "\n";	    
	    print "SN:               ".$r3." dB";
	    print "\n";	    
	    print "CMTS upstream SN: ".($ups_sn/10)." dB";
	    print "\n";	    
	    print "Upstream rx power:   ".($ups_rx_power/10)." dBmV";
	    print "\n";	    
	    print "Upstream ID:      ".$upstream_id;
	    print "\n";
	    print "Ethernet traffic [in/out]: ".$inUsage_eth."/".$outUsage_eth;
	    print "\n";	    
	    print "USB traffic [in/out]:      ".$inUsage_usb."/".$outUsage_usb;
	    print "\n";	    
	    print "MTA traffic [in/out]:      ".$inUsage_mta."/".$outUsage_mta;
	    print "\n";	    
	    print "MTA RTP in/out:            ".$inUsage_rtp."/".$outUsage_rtp;
	    print "\n";	    
	    print "MTA lost packets:          ".$lost_rtp;	    
	    print "\n";	    
	    print "=============================================================================\n";	    

	    insert();

            #For downstream and upstream frequency
            $SERVICEDESC="CM_FR";
	    $SERVICEOUTPUT="OK";
	    $SERVICEPERFDATA="downstream_fr=$down_fr upstream_fr=$up_fr";
	    $dane="$time||$ip||$SERVICEDESC||$SERVICEOUTPUT||$SERVICEPERFDATA";
            print "\n".$dane."\n";
            insert();
	}
}
exit;


# Read in config file
#
sub readconfig {
  # Make sure rrddir exist and is writable
  unless ( -w $rrddir ) {
    mkdir $rrddir;
    die "rrd dir $rrddir not writable" unless -w $rrddir;
  }
}

# Parse performance data from input
#
sub parseinput {
  my $data = shift;
  #debug(5, "INSERT perfdata: $data");
  my @d = split( /\|\|/, $data);
  return ( lastcheck    => $d[0],
           hostname     => $d[1],
           servicedescr => $d[2],
           output       => $d[3],
           perfdata     => $d[4],
         );
}

# Write debug information to log file
#
sub debug { 
  my($l, $text) = @_;
  if ( $l <= $debug ) {
    $l = qw(none critical error warn info debug)[$l];
    $text =~ s/(\w+)/$1 $l:/;
    open LOG, ">>$logfile";
      print LOG scalar localtime;
      print LOG " $text\n";
    close LOG;
  }
}

# Dump to log the files read from Nagios
#
sub dumpperfdata {
  my %P = @_;
  for ( keys %P ) {
    debug(4, "INSERT Input $_:$P{$_}");
  }
}

# URL encode a string
#
sub urlencode {
  $_[0] =~ s/([\W])/"%" . uc(sprintf("%2.2x",ord($1)))/eg;
  return $_[0];
}

# Create new rrd databases if necessary
#
sub createrrd {
  my($host,$service,$start,$labels) = @_;
  my($f,$v,$t,$ds,$db);

  $db = shift @$labels;
  $f = urlencode("${host}_${service}_${db}") . '.rrd';
  debug(5, "INSERT Checking $rrddir/$f");
  unless ( -e "$rrddir/$f" ) {
    $ds = "$rrddir/$f --start $start";
    for ( @$labels ) {
      ($v,$t) = ($_->[0],$_->[1]);
      $t="GAUGE";
      my $u = $t eq 'DERIVE' ? '0' : 'U' ;
      $ds .= " DS:$v:$t:$heartbeat:$u:U";
    }
    $ds .= " RRA:AVERAGE:0.5:1:600";
    $ds .= " RRA:AVERAGE:0.5:6:700";
    $ds .= " RRA:AVERAGE:0.5:24:775";
    $ds .= " RRA:AVERAGE:0.5:288:797";
    $ds .= " RRA:MAX:0.5:1:600";
    $ds .= " RRA:MAX:0.5:6:700";
    $ds .= " RRA:MAX:0.5:24:775";
    $ds .= " RRA:MAX:0.5:288:797";

    my @ds = split /\s+/, $ds;
    debug(4, "INSERT RRDs::create $ds");
    print "Create RRDs file: $f\n";
    RRDs::create(@ds);
    debug(2, "INSERT RRDs::create ERR " . RRDs::error) if RRDs::error;
  }
  return $f;
}

# Use RRDs to update rrd file
#
sub rrdupdate {
  my($file,$time,$values) = @_;
  my($ds,$c);

  $ds = "$rrddir/$file $time";
  for ( @$values ) {
    $_->[2] ||= 0;
    $ds .= ":$_->[2]";
  }

  my @ds = split /\s+/, $ds;
  debug(4, "INSERT RRDs::update ". join ' ', @ds);
  print "Update RRDs file: $file\n";
  RRDs::update(@ds);
  debug(2, "INSERT RRDs::update ERR " . RRDs::error) if RRDs::error;
}

# See if we can recognize any of the data we got
#
sub parseperfdata {
  my %P = @_;

  $_="servicedescr:$P{servicedescr}\noutput:$P{output}\nperfdata:$P{perfdata}";
  evalrules($_);
}

# Check that we have some data to work on
#
sub inputdata {
  my @inputlines;
  if ( $ARGV[0] ) {
    @inputlines = $ARGV[0];
  } elsif ( defined $Config{perflog} ) {
    open PERFLOG, $Config{perflog};
      @inputlines = <PERFLOG>;
    close PERFLOG
  }

  # Quit if there are no data to process
  unless ( @inputlines ) {
    debug(4, 'INSERT No inputdata. Exiting.');
    exit 1;
  }
  return @inputlines;
}

# Process all input performance data
#
sub processdata {
  my @perfdatalines = @_;
  for my $l ( @perfdatalines ) {
    debug(5, "INSERT processing perfdata: $l");
    print "=============================================================================\n";
    print "INSERT processing perfdata: $l";
    print "\n";
    my %P = parseinput($l);
    dumpperfdata(%P);
    my $S = parseperfdata(%P);
    for my $s ( @$S ) {
      my $rrd = createrrd($P{hostname}, $P{servicedescr}, $P{lastcheck}-1, $s);
      rrdupdate($rrd, $P{lastcheck}, $s);
    }
  }
}

sub insert {
### Main loop
#  - Read config and input
#  - Update rrd files
#  - Create them first if necesary.

    readconfig();
    my @perfdata = $dane;

    # Read the map file and define a subroutine that parses performance data
    my($rules);
    undef $/;
    open FH, $mapfile;
	$rules = <FH>;
    close FH;
    $rules = '
    sub evalrules {
	$_=$_[0];
	my @s;
	no strict "subs";
	' . $rules . '
	use strict "subs";
	debug(3, "INSERT perfdata not recognized") unless @s;
	return \@s;
    }';
    undef $@;
    eval $rules;
    debug(2, "INSERT Map file eval error: $@") if $@;

    processdata( @perfdata );
}
