<?php
/**
 * @package         CMWatch server
 * @copyright       Copyright (C) 2012 Mariusz Dziewulski. All rights reserved.
 * @license         see LICENSE.txt
 * CMWatch server is free software only for non commercial use.
 */

 class CM_check_modem
   {
      var $snmp_timeout=1000000; //in us
      var $snmp_retries=1;
      
      var $cm_vendors=array();
      var $vendor;
      var $model;
      var $community_ro;
      var $community_rw;
      var $cmts_ip;
      var $cmts_ro_community;
      var $cmts_rw_community;
      var $cmts_vendor;
      var $refresh_interval;
      var $downstream_id=array();
      var $is_auto_check;
      var $s_ping;

      var $ip_address;

      var $zastap = array("INTEGER:","IpAddress:","STRING:","HEX-:","Timeticks:","Hex-","Hex-STRING: ","<>","Counter32:",'"',"<",">","Gauge32:","ethernetCsmacd(6)","softwareLoopback(24)","other(1)");
      var $log1=    array();
      var $mac_cpe= array();
      var $lp=      array();
      var $ip_cpe=  array();

      var $system;
      var $location;
      var $name;
      
      var $downstream_frequency;
      var $downstream_annex;
      var $downstream_chan_id;
      var $downstream_chan_opis;
      var $downstream_sn;
      var $downstream_microref;
      var $downstream_power;
      var $downstream_modulation;
      var $downstream_bandwidth;
      var $downstream_code_feccorr;
      var $downstream_code_fecuncorr;
      var $downstream_traffic;
      var $downstream_code_unerror;
      var $downstream_code_correct;
      var $downstream_code_uncorrect;
      
      var $upstream_frequency;
      var $upstream_chan_id;
      var $upstream_modulation;
      var $upstream_tx_power;
      var $upstream_rx_power;
      var $upstream_sn;
      var $upstream_bandwidth;
      var $upstream_code_feccorr;
      var $upstream_code_fecuncorr;
      var $upstream_traffic;
      var $upstream_code_unerror;
      var $upstream_code_correct;
      var $upstream_code_uncorrect;
      
      var $other_t1;
      var $other_t2;
      var $other_t3;
      var $other_t4;
      var $other_dhcp_ip;
      var $other_docsis_ver;
      var $other_docsis_ver_int;
      var $other_docsis_ver_text;
      var $other_tod_ip;
      var $other_tftp_ip;
      var $other_hfc_mac;
      var $other_eth_mac;
      var $other_usb_mac;
      var $other_eth_ip;
      var $other_cm_model;
      var $other_cm_serial;
      var $other_cm_uptime;
      var $other_cm_restart;
      var $other_config_file;
      var $other_soft_ver;
      var $other_soft_file;
      var $other_hw_ver;
      var $other_mta_file;
      var $other_mta_ip;
      var $other_cm_ip_gateway;
      var $other_cm_ip_mask;
      
      var $cm_state;
      var $cm_state_cmts;
      var $cm_state_cmts_cisco;
      var $state_cpe;
      var $cmts_mac_domain;
      var $cmts_mac_domain_description;
      var $cmts_mac_domain_interface_mtu;
      var $cmts_mac_domain_interface_adm_stat;
      var $cmts_mac_domain_interface_oper_stat;
      var $cmts_mac_domain_in_traffic;
      var $cmts_mac_domain_out_traffic;
      var $cmts_mac_domain_in_errors;
      var $cmts_mac_domain_out_errors;  

      var $sfid=array();
      var $docsQosServiceFlowSID=array();
      var $docsQosServiceFlowDirection=array();
      var $docsQosServiceFlowPrimary=array();
      var $docsQosServiceFlowPkts=array();
      var $docsQosServiceFlowOctets=array();
      var $docsQosServiceFlowPolicedDropPkts=array();
      var $docsQosServiceFlowPolicedDelayPkts=array();
      var $docsQosServiceFlowTimeActive=array();
      var $docsQosPktClassState=array();
      var $docsQosParamSetMaxTrafficRate=array();
      var $docsQosParamSetMaxTrafficBurst=array();
      var $docsQosParamSetMinReservedRate=array();
      var $docsQosParamSetMinReservedPkt=array();
      var $docsQosParamSetSchedulingType=array();

      var $dss3_opis=array();
      var $dss3_fr=array();
      var $dss3_admin_st=array();
      var $dss3_oper_st=array();
      var $dss3_power=array();
      var $dss3_sn=array();
      var $dss3_uner=array();
      var $dss3_cor=array();
      var $dss3_uncor=array();
      var $dss3_microref=array();

      var $uss3_opis=array();
      var $uss3_fr=array();
      var $uss3_admin_st=array();
      var $uss3_oper_st=array();
      var $uss3_power=array();
      var $uss3_chan_id=array();
      var $uss3_bandwith=array();

      var $usb_status;
      var $usb_admin_st;
      var $usb_oper_st;
      var $eth_admin_st;
      var $eth_oper_st;

      var $mta_lines;
      var $vqm=array();
      var $vqm2=array();
      var $vqm3=array();
      var $vqm_description=array();
      var $vqm2_description=array();
      var $vqm3_description=array();      
      var $MtaDevProvState;
      var $MtaDevQosMode;
      var $MtaDevCallStatsEndPntOpStatus=array();
      var $MtaDevCallStatsLineSubState=array();
      var $ProvisioningStatusLastUpdate;
      
      var $tpl_file;
      var $tpl_toolbar;

      public function __construct($ip_address)
      {
         require("config.php"); 
         
         $this->ip_address = $ip_address;

         $this->community_ro=$community_ro;
         $this->community_rw=$community_rw;
         $this->cmts_ip=$cmts_ip;
         $this->cmts_ro_community=$cmts_ro_community;
         $this->cmts_rw_community=$cmts_rw_community;
         $this->cmts_vendor=$cmts_vendor;
         $this->refresh_interval=$refresh_interval;
         $this->downstream_id=$downstream_id;
         $this->cm_vendors=$cm_vendors;
    
         if (isset($_SESSION["cm_read_community"]))       {$this->community_ro=$_SESSION["cm_read_community"];}
         if (isset($_SESSION["cm_readwrite_community"]))  {$this->community_rw=$_SESSION["cm_readwrite_community"];}
         if (isset($_SESSION["cmts_ip"]))                 {$this->cmts_ip=$_SESSION["cmts_ip"];}
         if (isset($_SESSION["cmts_read_community"]))     {$this->cmts_ro_community=$_SESSION["cmts_read_community"];}
         if (isset($_SESSION["cmts_readwrite_community"])){$this->cmts_rw_community=$_SESSION["cmts_readwrite_community"];}
         if (isset($_SESSION["refresh_interval_conf"]))   {$this->refresh_interval=$_SESSION["refresh_interval_conf"];}
      }

      function dec2bin($decimalnumber)
      {   
        $maxval = 1;
        $sumval = 1;
        for($i=1;$i<8;$i++)
        {
            $maxval = $maxval * 2;
            $sumval = $sumval + $maxval;
        }
        if ($sumval < $decimalnumber) return 'ERROR - Not enough bits to display this figure in binary.';
        for($bitvalue=$maxval;$bitvalue>=1;$bitvalue=$bitvalue/2)
        {
            if (($decimalnumber/$bitvalue) >= 1) $thisbit = 1; else $thisbit = 0;
            if ($thisbit == 1) $decimalnumber = $decimalnumber - $bitvalue;   
            $binarynumber .= $thisbit;
        }
        return $binarynumber;
      }
      
      function set_mac($mac)
      {
         list($mac1,$mac2,$mac3,$mac4,$mac5,$mac6)=split(":",trim($mac));
         if ( $mac1[1]=="" ){$mac1='0'.$mac1;}
         if ( $mac2[1]=="" ){$mac2='0'.$mac2;}
         if ( $mac3[1]=="" ){$mac3='0'.$mac3;}
         if ( $mac4[1]=="" ){$mac4='0'.$mac4;}
         if ( $mac5[1]=="" ){$mac5='0'.$mac5;}
         if ( $mac6[1]=="" ){$mac6='0'.$mac6;}
         return $mac1.":".$mac2.":".$mac3.":".$mac4.":".$mac5.":".$mac6;
      }

      function snmp_get($oid = NULL)
      {
         return str_replace($this->zastap,"",snmpget($this->ip_address, $this->community_ro, $oid,$this->snmp_timeout,$this->snmp_retries));
      }

      function snmp_get_cmts($oid = NULL)
      {
         return str_replace($this->zastap,"",snmpget($this->cmts_ip, $this->cmts_ro_community, $oid,$this->snmp_timeout,$this->snmp_retries));
      }

      function snmp_walk($oid = NULL)
      {
         return snmpwalkoid($this->ip_address, $this->community_ro, $oid);
      }
      
      function snmp_set($oid, $value, $type)
      {
         return snmpset($this->ip_address, $this->community_rw, $oid, $type, $value);
      }

      function mta_diag()
      {
          //start 1.3.6.1.4.1.4115.1.3.3.1.2.3.15.1.1.3.1 =1
          //diag time: 1.3.6.1.4.1.4115.1.3.3.1.2.3.15.1.1.2.1
          //hazardous potential: 1.3.6.1.4.1.4115.1.3.3.1.2.3.15.1.1.5.1
          //foreign EMF: 1.3.6.1.4.1.4115.1.3.3.1.2.3.15.1.1.6.1
          //resistive faults: 1.3.6.1.4.1.4115.1.3.3.1.2.3.15.1.1.7.1
          //receive off hook: 1.3.6.1.4.1.4115.1.3.3.1.2.3.15.1.1.8.1
          //ringer equivalency: 1.3.6.1.4.1.4115.1.3.3.1.2.3.15.1.1.9.1          
      }
      
      function ping()
      {
         exec(sprintf('ping -c 1 -W 1 %s', $this->ip_address), $res, $ping);
         return $ping;
      }
      
      function check_vendor()
      {
          $hfc_mac=strtoupper($this->snmp_get("1.3.6.1.2.1.2.2.1.6.2"));
          list($mac1,$mac2,$mac3,$mac4,$mac5,$mac6)=split(":",trim($hfc_mac));
          if ( $mac1[1]=="" ){$mac1='0'.$mac1;}
          if ( $mac2[1]=="" ){$mac2='0'.$mac2;}
          if ( $mac3[1]=="" ){$mac3='0'.$mac3;}
          $hfc_mac=$mac1.":".$mac2.":".$mac3;
          if (array_key_exists($hfc_mac,$this->cm_vendors))
          {
              $this->vendor=$this->cm_vendors[$hfc_mac];
          } else $this->vendor=$this->cm_vendors[$hfc_mac];
          //check modem from system
          $sp=strrpos($this->system,"MODEL:");
          if(!($sp===false))
          {
              $this->model=substr($this->system,$sp+6);
          } else $this->model="";
          
         //$other_cm_gateway_ip;
         $this->other_cm_ip_mask=$this->snmp_get("1.3.6.1.2.1.4.20.1.3.".$this->ip_address);  
         list($a, $b, $c, $d)= split('\\.',$this->ip_address);
         $a=$this->dec2bin($a);
         $b=$this->dec2bin($b);
         $c=$this->dec2bin($c);
         $d=$this->dec2bin($d);
         list($ma,$mb,$mc,$md)=split('\\.',$this->other_cm_ip_mask);
         $ma=$this->dec2bin($ma);
         $mb=$this->dec2bin($mb);
         $mc=$this->dec2bin($mc);
         $md=$this->dec2bin($md);        
         $this->other_cm_ip_gateway=bindec($a&$ma).'.'.bindec($b&$mb).'.'.bindec($c&$mc).'.'.(bindec($d&$md)+1);
         
         if(trim($this->cmts_ip=="")) $this->cmts_ip=$this->other_cm_ip_gateway;
         $_SESSION["cmts_ip"]=$this->cmts_ip;
      }

      function check_is_auto_check()
      {
        $handle=fopen('./check_cm_modem_ip.dat',"r");
        $line = '';
        $this->is_auto_check="<font color='#FF0000'>&nbsp;Auto check is OFF</font></a>";
        while (($line = fgets($handle, 4096)) !== false)
        {
            if ((trim($line)==$this->ip_address)) 
                $this->is_auto_check="<font color='#008000'>Auto check is ON</font></a>";
        }
        fclose($handle);
      }
      
      function downstream_check()
      {
         $this->downstream_frequency= $this->snmp_get("1.3.6.1.2.1.10.127.1.1.1.1.2.3");
         $this->downstream_annex=     $this->snmp_get("1.3.6.1.2.1.10.127.1.1.1.1.7.3");
         switch ($this->downstream_annex)
         {
             case 1: $this->downstream_annex="unknow";
                 break;
             case 2: $this->downstream_annex="other";
                 break;
             case 3: $this->downstream_annex="annexA";
                 break;
             case 4: $this->downstream_annex="annexB";
                 break;
             case 5: $this->downstream_annex="annexC";
                 break;             
         }    
         $this->downstream_chan_id=   $this->snmp_get("1.3.6.1.2.1.10.127.1.1.1.1.1.3");
         $this->downstream_sn	   =  $this->snmp_get("1.3.6.1.2.1.10.127.1.1.4.1.5.3")/10;
         $_SESSION["downstream_sn_".$this->ip_address]=$this->downstream_sn;
         $this->downstream_microref = $this->snmp_get("1.3.6.1.2.1.10.127.1.1.4.1.6.3");
         $this->downstream_power    = $this->snmp_get("1.3.6.1.2.1.10.127.1.1.1.1.6.3")/10;
         $_SESSION["downstream_power_".$this->ip_address]=$this->downstream_power;
         $this->downstream_modulation=$this->snmp_get("1.3.6.1.2.1.10.127.1.1.1.1.4.3");
         if ( $this->downstream_modulation == "3" ){
            $this->downstream_modulation = "64 QAM";
         }
         if ( $this->downstream_modulation == "4" ){
            $this->downstream_modulation = "256 QAM";
         }
         if ( $this->downstream_modulation == "5" ){
            $this->downstream_modulation = "512 QAM";
         }
         if ( $this->downstream_modulation == "6" ){
            $this->downstream_modulation = "1024 QAM";
         }
         $this->downstream_bandwidth=$this->snmp_get("1.3.6.1.2.1.10.127.1.1.1.1.3.3");

         $this->downstream_traffic='';
         $trf1=$this->snmp_get("1.3.6.1.2.1.2.2.1.10.3");
         if ($trf1<0) {$trf1=$trf1*(-1);}
         $trf2=$trf1;
         if ($_SESSION["downstream_traffic_".$this->ip_address]=='') {$_SESSION["downstream_traffic_".$this->ip_address]=$trf2;}
         else {$trf2=$_SESSION["downstream_traffic_".$this->ip_address];}

         $trf=($trf1-$trf2)/(1024*(5));
         if ($trf<0) {$trf=$trf*(-1);}
         $this->downstream_traffic=round(($trf*8),3);
         $_SESSION["downstream_traffic_".$this->ip_address]=$trf1;
         $_SESSION["downstream_traffic_2_".$this->ip_address]=$trf;

         $this->downstream_code_unerror=  $this->snmp_get("1.3.6.1.2.1.10.127.1.1.4.1.2.3");
         $this->downstream_code_correct=  $this->snmp_get("1.3.6.1.2.1.10.127.1.1.4.1.3.3");
         $this->downstream_code_uncorrect=$this->snmp_get("1.3.6.1.2.1.10.127.1.1.4.1.4.3");

         $C0=$this->downstream_code_unerror;
         if ($C0<0) {$C0=$C0*(-1);}
         $C1=$C0;
         if ($_SESSION["downstream_code_unerror_".$this->ip_address]=='') {$_SESSION["downstream_code_unerror_".$this->ip_address]=$C1;}
         else {$C1=$_SESSION["downstream_code_unerror_".$this->ip_address];}
         $_SESSION["downstream_code_unerror_".$this->ip_address]=$C1;

         $Ec0=$this->downstream_code_correct;
         if ($Ec0<0) {$Ec0=$Ec0*(-1);}
         $Ec1=$Ec0;
         if ($_SESSION["downstream_code_correct_".$this->ip_address]=='') {$_SESSION["downstream_code_correct_".$this->ip_address]=$Ec1;}
         else {$Ec1=$_SESSION["downstream_code_correct_".$this->ip_address];}
         $_SESSION["downstream_code_correct_".$this->ip_address]=$Ec1;
         $Eu0=$this->downstream_code_uncorrect;
         if ($Eu0<0) {$Eu0=$Eu0*(-1);}
         $Eu1=$Eu0;
         if ($_SESSION["downstream_code_uncorrect_".$this->ip_address]=='') {$_SESSION["downstream_code_uncorrect_".$this->ip_address]=$Eu1;}
         else {$Eu1=$_SESSION["downstream_code_uncorrect_".$this->ip_address];}
         $_SESSION["downstream_code_uncorrect_".$this->ip_address]=$Eu1;
         $fec_c=0;
         $fec_c=(($Ec1 - $Ec0)/ (($Eu1 - $Eu0) + ($Ec1 - $Ec0) + ($C1 - $C0))) * 100;
         if ($fec_c<0) {$fec_c=$fec_c*(-1);}
         $this->downstream_code_feccorr=round($fec_c,3); //%skorygowanych
         $fec_u=0;
         $fec_u=(($Eu1 - $Eu0)/ (($Eu1 - $Eu0) + ($Ec1 - $Ec0) + ($C1 - $C0))) * 100;
         if ($fec_u<0) {$fec_u=$fec_u*(-1);}
         $this->downstream_code_fecuncorr=round($fec_u,3); //% nieskorygowanych
      }

      function upstream_check()
      {
         $this->upstream_frequency=$this->snmp_get("1.3.6.1.2.1.10.127.1.1.2.1.2.4");
         $this->upstream_chan_id=  $this->snmp_get("1.3.6.1.2.1.10.127.1.1.2.1.1.4");
         $this->upstream=     $this->upstream_chan_id-1;
         $this->upstream='/U'.$this->upstream;
         $this->downstream_chan_opis=$this->downstream_id[trim($this->downstream_chan_id)].($this->upstream);
         $this->upstream_modulation=$this->snmp_get("1.3.6.1.2.1.10.127.1.2.2.1.16.2");
         if ( $this->upstream_modulation == "0" ){
            $this->upstream_modulation = "unknow";
         }
         if ( $this->upstream_modulation == "1" ){
            $this->upstream_modulation = "tdma";
         }
         if ( $this->upstream_modulation == "2" ){
            $this->upstream_modulation = "atdma";
         }
         if ( $this->upstream_modulation == "3" ){
            $this->upstream_modulation = "scdma";
         }
         if ( $this->upstream_modulation == "4" ){
            $this->upstream_modulation = "tdmaANDatdma";
         }
         $this->upstream_tx_power=$this->snmp_get("1.3.6.1.2.1.10.127.1.2.2.1.3.2")/10;
         $_SESSION["upstream_tx_power_".$this->ip_address]=$this->upstream_tx_power;
         
         //Read from cmts
         $this->read_from_cmts();
         //========================================================================================================================
      }

      function read_from_cmts()
      {
         $hfc_mac=$this->snmp_get("1.3.6.1.2.1.2.2.1.6.2");
         list($mac1,$mac2,$mac3,$mac4,$mac5,$mac6)=split(":",trim($hfc_mac));
         $dec_hfc_mac=hexdec($mac1).'.'.hexdec($mac2).'.'.hexdec($mac3).'.'.hexdec($mac4).'.'.hexdec($mac5).'.'.hexdec($mac6);
         $cm_sid=trim($this->snmp_get_cmts("1.3.6.1.2.1.10.127.1.3.7.1.2.".trim($dec_hfc_mac)));
         //for all cmts
         $cm_state_cmts=$this->snmp_get_cmts("1.3.6.1.2.1.10.127.1.3.3.1.9.".trim($cm_sid));
         switch ($cm_state_cmts)
         {
             case 1:  $this->cm_state_cmts="Other";
                 break;
             case 2:  $this->cm_state_cmts="Ranging";
                 break;
             case 3:  $this->cm_state_cmts="Ranging aborted";
                 break;
             case 4:  $this->cm_state_cmts="Ranging complete";
                 break;
             case 5:  $this->cm_state_cmts="IP complete";
                 break;
             case 6:  $this->cm_state_cmts="Registration complete";
                 break;
             case 7:  $this->cm_state_cmts="Access denied";
                 break;
             case 8:  $this->cm_state_cmts="Operational";
                 break;
             case 9:  $this->cm_state_cmts="Registered BPI initializing";
                 break;
             default: $this->cm_state_cmts="No data from CMTS";
         }
         //For Cisco CMTS
         $cm_state_cmts_cisco=$this->snmp_get_cmts("1.3.6.1.4.1.9.9.116.1.3.2.1.1.".$cm_sid);
         switch ($cm_state_cmts_cisco)
         {
             case 1:   $this->cm_state_cmts_cisco="Offline";
                 break;
             case 2:   $this->cm_state_cmts_cisco="Others";
                 break;
             case 3:   $this->cm_state_cmts_cisco="Init Ranging Rcvd";
                 break;
             case 4:   $this->cm_state_cmts_cisco="Init Dhcp Req Rcvd";
                 break;
             case 5:   $this->cm_state_cmts_cisco="Online Net Access Disabled";
                 break;
             case 6:   $this->cm_state_cmts_cisco="Online Kek Assigned";
                 break;
             case 7:   $this->cm_state_cmts_cisco="Online Tek Assigned";
                 break;
             case 8:   $this->cm_state_cmts_cisco="Reject Bad Mic";
                 break;
             case 9:   $this->cm_state_cmts_cisco="Reject Bad Cos";
                 break;
             case 10:  $this->cm_state_cmts_cisco="Kek Rejected";
                 break;
             case 11:  $this->cm_state_cmts_cisco="Tek Rejected";
                 break;
             case 12:  $this->cm_state_cmts_cisco="Online";
                 break;
             case 13:  $this->cm_state_cmts_cisco="Init Tftp Packet Rcvd";
                 break;
             case 14:  $this->cm_state_cmts_cisco="Init ToD Request Rcvd";
                 break;
             case 15:  $this->cm_state_cmts_cisco="Reset";
                 break;
             case 16:  $this->cm_state_cmts_cisco="Ranging In Progress";
                 break;
             case 17:  $this->cm_state_cmts_cisco="Ranging Completed";
                 break;
             case 18:  $this->cm_state_cmts_cisco="Dhcp Got Ip Address";
                 break;
             case 19:  $this->cm_state_cmts_cisco="Rej Stale Config";
                 break;
             case 20:  $this->cm_state_cmts_cisco="Rej Ip Spoof";
                 break;             
             case 21:  $this->cm_state_cmts_cisco="Rej Class Fail";
                 break;             
             case 22:  $this->cm_state_cmts_cisco="Rej Reg Nack";
                 break;             
             case 23:  $this->cm_state_cmts_cisco="BPI Kek Expired";
                 break;             
             case 24:  $this->cm_state_cmts_cisco="BPI Tek Expired";
                 break;             
             case 25:  $this->cm_state_cmts_cisco="Shutdown";
                 break;             
             case 26:  $this->cm_state_cmts_cisco="Channel Chg Init Ranging Rcvd";
                 break;             
             case 27:  $this->cm_state_cmts_cisco="Channel Chg Ranging In Progress";
                 break;                          
             default: $this->cm_state_cmts_cisco="";
         }
         
         $this->upstream_rx_power= round($this->snmp_get_cmts("1.3.6.1.2.1.10.127.1.3.3.1.6.".$cm_sid)/10,3);
         $this->upstream_sn=       round($this->snmp_get_cmts("1.3.6.1.2.1.10.127.1.3.3.1.13.".$cm_sid)/10,2);
         $this->upstream_bandwidth=      $this->snmp_get("1.3.6.1.2.1.10.127.1.1.2.1.3.4");
         $this->upstream_traffic='';
         $trf1=                     $this->snmp_get("1.3.6.1.2.1.2.2.1.16.4");
         if ($trf1<0) {$trf1=$trf1*(-1);}
         $trf2=$trf1;
         if ($_SESSION["upstream_traffic_".$this->ip_address]=='') {$_SESSION["upstream_traffic_".$this->ip_address]=$trf2;}
         else $trf2=$_SESSION["upstream_traffic_".$this->ip_address];

         $trf=($trf1-$trf2)/(1024*(5));
         if ($trf<0) {$trf=$trf*(-1);}
         $this->upstream_traffic=round(($trf*8),3);
         $_SESSION["upstream_traffic_".$this->ip_address]=$trf1;
         $_SESSION["upstream_traffic_2_".$this->ip_address]=$trf;

         $this->upstream_code_unerror=  $this->snmp_get_cmts("1.3.6.1.2.1.10.127.1.3.3.1.10".'.'.$cm_sid);
         if ($this->upstream_code_unerror=='') {$this->upstream_code_unerror=0;}

         $this->upstream_code_correct=  $this->snmp_get_cmts("1.3.6.1.2.1.10.127.1.3.3.1.11".'.'.$cm_sid);
         if ($this->upstream_code_correct=='') {$this->upstream_code_correct=0;}

         $this->upstream_code_uncorrect=$this->snmp_get_cmts("1.3.6.1.2.1.10.127.1.3.3.1.12".'.'.$cm_sid);
         if ($this->upstream_code_uncorrect=='') {$this->upstream_code_uncorrect=0;}

         $C0=$this->upstream_code_unerror;
         if ($C0<0) {$C0=$C0*(-1);}
         $C1=$C0;
         if ($_SESSION["upstream_code_unerror_".$this->ip_address]=='') {$_SESSION["upstream_code_unerror_".$this->ip_address]=$C1;}
         else {$C1=$_SESSION["upstream_code_unerror_".$this->ip_address];}
         $_SESSION["upstream_code_unerror_".$this->ip_address]=$C1;

         $Ec0=$this->upstream_code_correct;
         if ($Ec0<0) {$Ec0=$Ec0*(-1);}
         $Ec1=$Ec0;
         if ($_SESSION["upstream_code_correct_".$this->ip_address]=='') {$_SESSION["upstream_code_correct_".$this->ip_address]=$Ec1;}
         else {$Ec1=$_SESSION["upstream_code_correct_".$this->ip_address];}
         $_SESSION["upstream_code_correct_".$this->ip_address]=$Ec1;
         $Eu0=$this->upstream_code_uncorrect;
         if ($Eu0<0) {$Eu0=$Eu0*(-1);}
         $Eu1=$Eu0;
         if ($_SESSION["upstream_code_uncorrect_".$this->ip_address]=='') {$_SESSION["upstream_code_uncorrect_".$this->ip_address]=$Eu1;}
         else {$Eu1=$_SESSION["upstream_code_uncorrect_".$this->ip_address];}
         $_SESSION["upstream_code_uncorrect_".$this->ip_address]=$Eu1;
         $fec_c=0;
         $fec_c=(($Ec1 - $Ec0)/ (($Eu1 - $Eu0) + ($Ec1 - $Ec0) + ($C1 - $C0))) * 100;
         if ($fec_c<0) {$fec_c=$fec_c*(-1);}
         $this->upstream_code_feccorr=round($fec_c,3); //%skorygowanych
         $fec_u=0;
         $fec_u=(($Eu1 - $Eu0)/ (($Eu1 - $Eu0) + ($Ec1 - $Ec0) + ($C1 - $C0))) * 100;
         if ($fec_u<0) {$fec_u=$fec_u*(-1);}
         $this->upstream_code_fecuncorr=round($fec_u,3); //% nieskorygowanych          
      }
      
      function other_check()
      {
         $this->other_t1=$this->snmp_get("1.3.6.1.2.1.10.127.1.2.2.1.10.2");
         $this->other_t2=$this->snmp_get("1.3.6.1.2.1.10.127.1.2.2.1.11.2");
         $this->other_t3=$this->snmp_get("1.3.6.1.2.1.10.127.1.2.2.1.12.2");
         $this->other_t4=$this->snmp_get("1.3.6.1.2.1.10.127.1.2.2.1.13.2");
                          
         $this->other_dhcp_ip=       $this->snmp_get("1.3.6.1.2.1.69.1.4.2.0");
         $this->other_docsis_ver_int=$this->snmp_get("1.3.6.1.2.1.10.127.1.1.5.0");
         switch ($this->other_docsis_ver_int)
         {
            case 0: $tmp='docsis 1.0';
               break;
            case 1: $tmp='docsis 1.1';
               break;
            case 2: $tmp='docsis 2.0';
               break;
            case 3: $tmp='docsis 2.0';
               break;
            case 4: $tmp='docsis 3.0';
               break;
         }
         $this->other_docsis_ver=$tmp;

         $this->other_tod_ip=$this->snmp_get("1.3.6.1.2.1.69.1.4.3.0");
         $this->other_tftp_ip=$this->snmp_get("1.3.6.1.2.1.69.1.4.4.0");
         $this->other_hfc_mac=$this->set_mac($this->snmp_get("1.3.6.1.2.1.2.2.1.6.2"));
         $this->other_eth_mac=$this->set_mac($this->snmp_get("1.3.6.1.2.1.2.2.1.6.1"));
         $this->other_usb_mac=$this->set_mac($this->snmp_get("1.3.6.1.2.1.2.2.1.6.5"));
         
         $this->usb_status=  trim($this->snmp_get( "1.3.6.1.3.103.1.3.1.7.1"));
         $this->usb_admin_st=trim($this->snmp_get( "1.3.6.1.2.1.2.2.1.7.5"));
         $this->usb_oper_st= trim($this->snmp_get( "1.3.6.1.2.1.2.2.1.8.5"));         
         switch ($this->usb_status)
         {
             case 1: $this->usb_status='unattached';
                 break;
             case 2: $this->usb_status='attached';
                 break;
             case 3: $this->usb_status='powered';
                 break;
             case 4: $this->usb_status='"default"';
                 break;
             case 5: $this->usb_status='address';
                 break;
             case 6: $this->usb_status='configured';
                 break;
             case 7: $this->usb_status='sespended';
                 break;             
         }         

         $this->eth_admin_st=trim($this->snmp_get( "1.3.6.1.2.1.2.2.1.7.1"));
         $this->eth_oper_st= trim($this->snmp_get( "1.3.6.1.4.1.1429.77.1.4.1.0")); //dla epc3212
         if ($this->eth_oper_st == "")
         {
            $this->eth_oper_st= $this->snmp_get( "1.3.6.1.2.1.2.2.1.8.1");
         } else {
               switch ($this->eth_oper_st)
               {
                  case 0: $this->eth_oper_st='autoNegotiation';
                     break;
                  case 1: $this->eth_oper_st='half-duplex-10Mbps';
                     break;
                  case 2: $this->eth_oper_st='full-duplex-10Mbps';
                     break;
                  case 3: $this->eth_oper_st='half-duplex-100Mbps';
                     break;
                  case 4: $this->eth_oper_st='full-duplex-100Mbps';
                     break;
                  case 5: $this->eth_oper_st='ethernetNotConnected';
                     break;
                  case 6: $this->eth_oper_st='half-duplex-1Gbps';
                     break;
                  case 7: $this->eth_oper_st='full-duplex-1Gbps';
                     break;
               }
          }
          
         $this->other_eth_ip=$this->snmp_get("1.3.6.1.2.1.4.20.1.1");
         $this->other_cm_model=$this->snmp_get("1.3.6.1.2.1.1.5.0");
         if ($this->other_cm_model=='')
         {
            $this->other_cm_model=$this->snmp_get("1.3.6.1.2.1.1.1.0");
         }
         $this->other_cm_serial=$this->snmp_get("1.3.6.1.2.1.69.1.1.4.0");
         $this->other_cm_uptime=$this->snmp_get("1.3.6.1.2.1.1.3.0");
         $this->other_cm_restart=$this->snmp_get("1.3.6.1.2.1.1.8.0");

         $this->other_config_file=$this->snmp_get("1.3.6.1.2.1.69.1.4.5.0");
         $this->other_soft_ver=$this->snmp_get("1.3.6.1.2.1.69.1.3.5.0");
         $this->other_soft_file=$this->snmp_get("1.3.6.1.2.1.69.1.3.2.0");
         $this->other_hw_ver='';
         $this->other_mta_file=$this->snmp_get("1.3.6.1.4.1.4115.1.3.3.1.1.2.1.5.0");
         $this->other_mta_ip=$this->snmp_get("1.3.6.1.4.1.4115.1.3.3.1.1.2.1.2.0");         
      }

      function standby_check()
      {
         $this->standby=$this->vendor; 
         switch ($this->vendor)
         {
             case "RCA/Thomso": {
                                $oid='1.3.6.1.4.1.2863.205.1.1.20.0';
                                $this->standby_int=$this->snmp_get($oid);
                                switch ($this->standby_int)
                                {
                                    case "07": $this->standby='<a href="#" onclick="set_standby_off('."'".$this->ip_address."'".','."'".$oid."'".','.'07'.');return false;">'."<font color='#008000'><b>StandBy is OFF</b></font></a>";
                                        break;
                                    case "0F": $this->standby='<a href="#" onclick="set_standby_off('."'".$this->ip_address."'".','."'".$oid."'".','.'07'.');return false;">'."<font color='#FF0000'><b>StandBy is ON</b></font></a>";
                                        break;
                                }
                        }
                    break;
             case "Arris":  {
                             $oid='1.3.6.1.4.1.4115.1.3.1.1.1.1.0';
                             $this->standby_int=$this->snmp_get($oid);
                             switch ($this->standby_int)
                             {
                                 case 1: $this->standby='<a href="#" onclick="set_standby_off('."'".$this->ip_address."'".','."'".$oid."'".','.'1'.');return false;">'."<font color='#008000'><b>off-InActiveMode(1)</b></font></a>";
                                     break;
                                 case 2: $this->standby='<a href="#" onclick="set_standby_off('."'".$this->ip_address."'".','."'".$oid."'".','.'1'.');return false;">'."<font color='#FF0000'><b>on-ActiveMode(2)</b></font></a>";
                                     break;
                                 case 3: $this->standby='<a href="#" onclick="set_standby_off('."'".$this->ip_address."'".','."'".$oid."'".','.'1'.');return false;">'."<font color='#008000'><b>off-InActiveMode-ButtonDisabled(3)</b></font></a>";
                                     break;
                                 case 4: $this->standby='<a href="#" onclick="set_standby_off('."'".$this->ip_address."'".','."'".$oid."'".','.'1'.');return false;">'."<font color='#008000'><b>on-ActiveMode-ButtonDisabled(4)</b></font></a>";
                                     break;
                             }
                    }
                    break;
             case "Motorola":{
                             $oid='1.3.6.1.4.1.1166.1.19.3.1.19.0';
                             $this->standby_int=$this->snmp_get($oid);
                             switch ($this->standby_int)
                             {
                                 case 2: $this->standby='<a href="#" onclick="set_standby_off('."'".$this->ip_address."'".','."'".$oid."'".','.'2'.');return false;">'."<font color='#008000'><b>StandBy is OFF</b></font></a>";
                                     break;
                                 case 1: $this->standby='<a href="#" onclick="set_standby_off('."'".$this->ip_address."'".','."'".$oid."'".','.'2'.');return false;">'."<font color='#FF0000'><b>StandBy is ON</b></font></a>";
                                     break;
                             }
                    }         
                    break;
                 
         } 
         $this->cm_state=$this->standby;
      }


      function docsis3_check_downstream()
      {
         //$hfc_mac=$this->snmp_get("1.3.6.1.2.1.2.2.1.6.2"));
         //list($mac1,$mac2,$mac3,$mac4,$mac5,$mac6)=split(":",trim($hfc_mac));
         //$dec_hfc_mac=hexdec($mac1).'.'.hexdec($mac2).'.'.hexdec($mac3).'.'.hexdec($mac4).'.'.hexdec($mac5).'.'.hexdec($mac6);
         $a = snmpwalkoid($this->ip_address, $this->community_ro, "1.3.6.1.2.1.2.2.1.3");
         for (reset($a); $i = key($a); next($a))
         {
            $sfid=substr($i,strrpos($i,'.')+1); //zostaje 86 87 6226
            $oid=$sfid; //trim(str_replace($zastap,"",$a[$i])).'.'.$sfid; //1001.86 itd
            $typ=$this->snmp_get("1.3.6.1.2.1.2.2.1.3.".$oid);
            if ($typ=='128') //downstream
            {
               $this->dss3_opis[]=$this->snmp_get("1.3.6.1.2.1.2.2.1.2.".$oid); //description
               $this->dss3_fr[]  =$this->snmp_get("1.3.6.1.2.1.10.127.1.1.1.1.2.".$oid); //fr
               $tmp=$this->snmp_get("1.3.6.1.2.1.2.2.1.7.".$oid); //admin state
               switch ($tmp)
               {
                  case 1: $tmp='up';
                     break;
                  case 2: $tmp='down';
                     break;
                  case 5: $tmp='dormant';
                     break;
               }
               $this->dss3_admin_st[]=$tmp;

               $tmp=$this->snmp_get("1.3.6.1.2.1.2.2.1.8.".$oid); //oper state
               switch ($tmp)
               {
                  case 1: $tmp='up';
                     break;
                  case 2: $tmp='down';
                     break;
                  case 5: $tmp='dormant';
                     break;
               }
               $this->dss3_oper_st[]=$tmp; //oper state

               $this->dss3_power[]=   $this->snmp_get("1.3.6.1.2.1.10.127.1.1.1.1.6.".$oid)/10; //power
               $this->dss3_sn[]=      $this->snmp_get("1.3.6.1.2.1.10.127.1.1.4.1.5.".$oid)/10; //sn
               $this->dss3_uner[]=    $this->snmp_get("1.3.6.1.2.1.10.127.1.1.4.1.2.".$oid); //unerroreds
               $this->dss3_cor[]=     $this->snmp_get("1.3.6.1.2.1.10.127.1.1.4.1.3.".$oid); //correcteds
               $this->dss3_uncor[]=   $this->snmp_get("1.3.6.1.2.1.10.127.1.1.4.1.4.".$oid); //uncorrecteds
               $this->dss3_microref[]=$this->snmp_get("1.3.6.1.2.1.10.127.1.1.4.1.6.".$oid); //microref
            }
         }
      }

      function docsis3_check_upstream()
      {
         //$a = snmpwalkoid($this->ip_address, $this->community_ro, "1.3.6.1.2.1.2.2.1.3");
         $a = $this->snmp_walk("1.3.6.1.2.1.2.2.1.3");
         for (reset($a); $i = key($a); next($a))
         {
            $sfid=substr($i,strrpos($i,'.')+1); //zostaje 86 87 6226
            $oid=$sfid; //trim(str_replace($zastap,"",$a[$i])).'.'.$sfid; //1001.86 itd
            $typ=$this->snmp_get("1.3.6.1.2.1.2.2.1.3.".$oid);
            if ($typ=='129') //upstream
            {
               $this->uss3_opis[]=$this->snmp_get("1.3.6.1.2.1.2.2.1.2.".$oid); //description
               $this->uss3_fr[]  =$this->snmp_get("1.3.6.1.2.1.10.127.1.1.2.1.2.".$oid); //fr
               $tmp=$this->snmp_get("1.3.6.1.2.1.2.2.1.7.".$oid); //admin state
               switch ($tmp)
               {
                  case 1: $tmp='up';
                     break;
                  case 2: $tmp='down';
                     break;
                  case 5: $tmp='dormant';
                     break;
               }
               $this->uss3_admin_st[]=$tmp;

               $tmp=$this->snmp_get("1.3.6.1.2.1.2.2.1.8.".$oid); //oper state
               switch ($tmp)
               {
                  case 1: $tmp='up';
                     break;
                  case 2: $tmp='down';
                     break;
                  case 5: $tmp='dormant';
                     break;
               }
               $this->uss3_oper_st[]= $tmp; //oper state
               $this->uss3_power[]   =$this->snmp_get("1.3.6.1.2.1.10.127.1.2.2.1.3.2")/10; //power do sprawdzenia
               $this->uss3_chan_id[] =$this->snmp_get("1.3.6.1.2.1.10.127.1.1.2.1.1.".$oid);
               $this->uss3_bandwith[]=$this->snmp_get("1.3.6.1.2.1.10.127.1.1.2.1.3.".$oid);
            }
         }
      }

      //For uBR10k
      function cpe_check_cisco()
      {
         //1.3.6.1.4.1.9.9.116.1.3.8.1.3. 96.42.208.196.24.19. 1.4. 84.38.85.86 = STRING: "T&UV"
         //                               <mac cm            >      <ip cpe     >
         $hfc_mac=$this->snmp_get("1.3.6.1.2.1.2.2.1.6.2");
         list($mac1,$mac2,$mac3,$mac4,$mac5,$mac6)=split(":",trim($hfc_mac));
         $dec_hfc_mac=hexdec($mac1).'.'.hexdec($mac2).'.'.hexdec($mac3).'.'.hexdec($mac4).'.'.hexdec($mac5).'.'.hexdec($mac6);
         $a = snmpwalkoid($this->cmts_ip, $this->cmts_ro_community, "1.3.6.1.4.1.9.9.116.1.3.8.1.3.".$dec_hfc_mac);
         $k=0;
         for (reset($a); $i = key($a); next($a))
         {
            $k++;
            $this->lp[]=$k;
            $cpe=str_replace("SNMPv2-SMI::enterprises.9.9.116.1.3.8.1.3.".$dec_hfc_mac.'.1.4.','',$i);
            $this->ip_cpe[]=$cpe;
            $fn= trim($this->snmp_get_cmts( "1.3.6.1.2.1.3.1.1.1.9721.1.".$cpe));
            $mac=trim($this->snmp_get_cmts( "1.3.6.1.2.1.4.22.1.2.".$fn.'.'.$cpe));
            $this->mac_cpe[]=$mac;
            $cpe_state   =$this->snmp_get_cmts( "1.3.6.1.2.1.4.22.1.4.".$fn.'.'.$cpe);
            $this->state_cpe[]=$cpe_state;
         }
      }

      //For Arris C4
      function cpe_check_arris()
      {
        #=== read from cmts (cadant)
        $hfc_mac=$this->snmp_get("1.3.6.1.2.1.2.2.1.6.2");        //from cm
        list($mac1,$mac2,$mac3,$mac4,$mac5,$mac6)=split(":",trim($hfc_mac));
        $dec_hfc_mac=hexdec($mac1).'.'.hexdec($mac2).'.'.hexdec($mac3).'.'.hexdec($mac4).'.'.hexdec($mac5).'.'.hexdec($mac6); //mac to dec
        $ip_cpe_tmp=   snmpwalkoid($this->cmts_ip,$this->cmts_ro_community,"1.3.6.1.4.1.4998.1.1.20.2.7.1.2".'.'.$dec_hfc_mac);
        $state_cpe_tmp=snmpwalkoid($this->cmts_ip,$this->cmts_ro_community,"1.3.6.1.4.1.4998.1.1.20.2.7.1.3".'.'.$dec_hfc_mac);
        $mac_cpe_tmp=  snmpwalkoid($this->cmts_ip,$this->cmts_ro_community,"1.3.6.1.4.1.4998.1.1.20.2.7.1.4".'.'.$dec_hfc_mac);
        $k=0;
        for (reset($ip_cpe_tmp);$i=key($ip_cpe_tmp);next($ip_cpe_tmp))
        {
            $k++;
            $this->lp[]=$k;
            $this->ip_cpe[]=   str_replace("IpAddress: ","",$ip_cpe_tmp[$i]);
            $this->mac_cpe[]=  str_replace(" ",":",trim(str_replace("Hex-STRING: ","",$mac_cpe_tmp[$i])));
            if (str_replace("INTEGER: ","",$state_cpe_tmp[$i])=="1")
            {
                $this->state_cpe[]='learned';
            } else $this->state_cpe[]='provisioned';
        }
      }

      //Read from CM
      function cpe_check_cm()
      {
         $mac   = snmpwalkoid($this->ip_address, $this->community_ro, "1.3.6.1.2.1.17.4.3.1.1");
         //$mac   = snmpwalkoid($this->ip_address, $this->community_ro, "1.3.6.1.2.1.17.4.3.1.2");
         $state = snmpwalkoid($this->ip_address, $this->community_ro, "1.3.6.1.2.1.17.4.3.1.3");
         $k=0;
         for (reset($mac); $i = key($mac); next($mac))
         {
            $k++;
            $this->lp[]=$k;
            $this->ip_cpe[]="...";
            $this->mac_cpe[]=trim(str_replace(' ',':',str_replace('Hex-STRING: ','',trim($mac[$i]))));
         }
         for (reset($state); $i = key($state); next($state))
         {
            $cpe_state      =trim(str_replace('INTEGER: ','',$state[$i]));
            switch ($cpe_state)
            {
                case "1": $this->state_cpe[]="1";
                    break;
                case "2": $this->state_cpe[]="2";
                    break;
                case "3": $this->state_cpe[]="Learned";
                    break;
                case "4": $this->state_cpe[]="Self";
                    break;
                case "5": $this->state_cpe[]="Mgmt";
                    break;
                default:  $this->state_cpe[]=$cpe_state;
             }
         }         
      }
      
      
      function show_cmts()
      {
         $this->cmts_mac_domain=str_replace(" ",':',trim($this->snmp_get("1.3.6.1.2.1.10.127.1.2.1.1.1.2"))); 
         $mac_domain=$this->set_mac($this->cmts_mac_domain);
         $this->cmts_mac_domain_description="";
         $b = snmpwalkoid($this->cmts_ip, $this->cmts_ro_community, "1.3.6.1.2.1.2.2.1.6");
         for (reset($b); $i = key($b); next($b))
         {
             if($this->set_mac(strtoupper(str_replace($this->zastap,"",$b[$i]))) == $mac_domain)
             {        
                list($nic,$indeks_snmp)=split('\\.',key($b));
                $this->cmts_mac_domain_description .=      $this->snmp_get_cmts("1.3.6.1.2.1.2.2.1.2.".$indeks_snmp).' ';
                $this->cmts_mac_domain_interface_mtu=      $this->snmp_get_cmts("1.3.6.1.2.1.2.2.1.4.".$indeks_snmp);
                $this->cmts_mac_domain_interface_adm_stat= $this->snmp_get_cmts("1.3.6.1.2.1.2.2.1.7.".$indeks_snmp);
                $this->cmts_mac_domain_interface_oper_stat=$this->snmp_get_cmts("1.3.6.1.2.1.2.2.1.8.".$indeks_snmp);
                
                $this->cmts_mac_domain_in_traffic='';
                $trf1=$this->snmp_get_cmts("1.3.6.1.2.1.2.2.1.10.".$indeks_snmp);
                if ($trf1<0) {$trf1=$trf1*(-1);}
                $trf2=$trf1;
                if ($_SESSION["cmts_mac_domain_in_traffic_".$this->cmts_mac_domain]=='') {$_SESSION["cmts_mac_domain_in_traffic_".$this->cmts_mac_domain]=$trf2;}
                else $trf2=$_SESSION["cmts_mac_domain_in_traffic_".$this->cmts_mac_domain];

                $trf=($trf1-$trf2)/(1024*(5));
                if ($trf<0) {$trf=$trf*(-1);}
                $this->cmts_mac_domain_in_traffic=round(($trf*8),3);
                $_SESSION["cmts_mac_domain_in_traffic_".$this->cmts_mac_domain]=$trf1;
                $_SESSION["cmts_mac_domain_in_traffic_2_".$this->cmts_mac_domain]=$trf;

                $this->cmts_mac_domain_out_traffic='';
                $trf1=$this->snmp_get_cmts("1.3.6.1.2.1.2.2.1.16.".$indeks_snmp);
                if ($trf1<0) {$trf1=$trf1*(-1);}
                $trf2=$trf1;
                if ($_SESSION["cmts_mac_domain_out_traffic_".$this->cmts_mac_domain]=='') {$_SESSION["cmts_mac_domain_out_traffic_".$this->cmts_mac_domain]=$trf2;}
                else $trf2=$_SESSION["cmts_mac_domain_out_traffic_".$this->cmts_mac_domain];

                $trf=($trf1-$trf2)/(1024*(5));
                if ($trf<0) {$trf=$trf*(-1);}
                $this->cmts_mac_domain_out_traffic=round(($trf*8),3);
                $_SESSION["cmts_mac_domain_out_traffic_".$this->cmts_mac_domain]=$trf1;
                $_SESSION["cmts_mac_domain_out_traffic_2_".$this->cmts_mac_domain]=$trf;                

                $this->cmts_mac_domain_in_errors='';
                $trf1=$this->snmp_get_cmts("1.3.6.1.2.1.2.2.1.14.".$indeks_snmp);
                if ($trf1<0) {$trf1=$trf1*(-1);}
                $trf2=$trf1;
                if ($_SESSION["cmts_mac_domain_in_errors_".$this->cmts_mac_domain]=='') {$_SESSION["cmts_mac_domain_in_errors_".$this->cmts_mac_domain]=$trf2;}
                else $trf2=$_SESSION["cmts_mac_domain_in_errors_".$this->cmts_mac_domain];

                $trf=($trf1-$trf2)/(1024*(5));
                if ($trf<0) {$trf=$trf*(-1);}
                $this->cmts_mac_domain_in_errors=round(($trf*8),3);
                $_SESSION["cmts_mac_domain_in_errors_".$this->cmts_mac_domain]=$trf1;
                $_SESSION["cmts_mac_domain_in_errors_2_".$this->cmts_mac_domain]=$trf;

                $this->cmts_mac_domain_out_errors='';
                $trf1=$this->snmp_get_cmts("1.3.6.1.2.1.2.2.1.20.".$indeks_snmp);
                if ($trf1<0) {$trf1=$trf1*(-1);}
                $trf2=$trf1;
                if ($_SESSION["cmts_mac_domain_out_errors_".$this->cmts_mac_domain]=='') {$_SESSION["cmts_mac_domain_out_errors_".$this->cmts_mac_domain]=$trf2;}
                else $trf2=$_SESSION["cmts_mac_domain_out_errors_".$this->cmts_mac_domain];

                $trf=($trf1-$trf2)/(1024*(5));
                if ($trf<0) {$trf=$trf*(-1);}
                $this->cmts_mac_domain_out_errors=round(($trf*8),3);
                $_SESSION["cmts_mac_domain_out_errors_".$this->cmts_mac_domain]=$trf1;
                $_SESSION["cmts_mac_domain_out_errors_2_".$this->cmts_mac_domain]=$trf;                
                //break;
             }
         }    
                           
         $hfc_mac=$this->snmp_get("1.3.6.1.2.1.2.2.1.6.2");
         list($mac1,$mac2,$mac3,$mac4,$mac5,$mac6)=split(":",trim($hfc_mac));
         $dec_hfc_mac=hexdec($mac1).'.'.hexdec($mac2).'.'.hexdec($mac3).'.'.hexdec($mac4).'.'.hexdec($mac5).'.'.hexdec($mac6);
         //echo $dec_hfc_mac;
         $a = snmpwalkoid($this->cmts_ip, $this->cmts_ro_community, "1.3.6.1.2.1.10.127.7.1.11.1.3.".$dec_hfc_mac);
         for (reset($a); $i = key($a); next($a))
         {
            $sfid=substr($i,strrpos($i,'.')+1);
            $oid=trim(str_replace($this->zastap,"",$a[$i])).'.'.$sfid;
            $this->sfid[]=str_replace($this->zastap,"",$sfid); //sfid
            $this->docsQosServiceFlowSID[]=$this->snmp_get_cmts("1.3.6.1.2.1.10.127.7.1.3.1.6.".$oid); //docsQosServiceFlowSID  SID
            $tmp=$this->snmp_get_cmts("1.3.6.1.2.1.10.127.7.1.3.1.7.".$oid); //docsQosServiceFlowDirection
            if ($tmp=='1') {$this->docsQosServiceFlowDirection[]="downstream(1)";}
            if ($tmp=='2') {$this->docsQosServiceFlowDirection[]="upstream(2)";}

            $tmp=$this->snmp_get_cmts("1.3.6.1.2.1.10.127.7.1.3.1.8.".$oid); //docsQosServiceFlowPrimary
            if ($tmp=='1') {$this->docsQosServiceFlowPrimary[]="*";}
            if ($tmp=='2') {$this->docsQosServiceFlowPrimary[]=" ";}

            $this->docsQosServiceFlowPkts[]=            $this->snmp_get_cmts("1.3.6.1.2.1.10.127.7.1.4.1.1.".$oid); //docsQosServiceFlowPkts
            $this->docsQosServiceFlowOctets[]=          $this->snmp_get_cmts("1.3.6.1.2.1.10.127.7.1.4.1.2.".$oid); //docsQosServiceFlowOctets
            $this->docsQosServiceFlowPolicedDropPkts[]= $this->snmp_get_cmts("1.3.6.1.2.1.10.127.7.1.4.1.6.".$oid); //docsQosServiceFlowPolicedDropPkts
            $this->docsQosServiceFlowPolicedDelayPkts[]=$this->snmp_get_cmts("1.3.6.1.2.1.10.127.7.1.4.1.7.".$oid); //docsQosServiceFlowPolicedDelayPkts
            $this->docsQosServiceFlowTimeActive[]=      $this->snmp_get_cmts("1.3.6.1.2.1.10.127.7.1.4.1.4.".$oid); //docsQosServiceFlowTimeActive
            
            $tmp=$this->snmp_get_cmts("1.3.6.1.2.1.10.127.7.1.1.1.25.".$oid.'.1'); //docsQosPktClassState
            if ($tmp=='1') {$this->docsQosPktClassState[]="active(1)";}
            if ($tmp=='2') {$this->docsQosPktClassState[]="inactive(2)";}

            $this->docsQosParamSetMaxTrafficRate[]= $this->snmp_get_cmts("1.3.6.1.2.1.10.127.7.1.2.2.6.". $oid.'.1'); //docsQosParamSetMaxTrafficRate
            $this->docsQosParamSetMaxTrafficBurst[]=$this->snmp_get_cmts("1.3.6.1.2.1.10.127.7.1.2.2.7.". $oid.'.1'); //docsQosParamSetMaxTrafficBurst
            $this->docsQosParamSetMinReservedRate[]=$this->snmp_get_cmts("1.3.6.1.2.1.10.127.7.1.2.2.8.". $oid.'.1'); //docsQosParamSetMinReservedRate
            $this->docsQosParamSetMinReservedPkt[]= $this->snmp_get_cmts("1.3.6.1.2.1.10.127.7.1.2.2.9.". $oid.'.1'); //docsQosParamSetMinReservedPkt
            $this->docsQosParamSetSchedulingType[]= $this->snmp_get_cmts("1.3.6.1.2.1.10.127.7.1.2.2.13.".$oid.'.1');//docsQosParamSetSchedulingType
        }
      }

      function show_mta()
      {
         $this->mta_lines=      $this->snmp_get("1.3.6.1.4.1.4491.2.1.14.1.1.2.1.2.16"); #state MTA interface
         $MtaDevQosMode=  $this->snmp_get("1.3.6.1.4.1.4115.1.3.3.1.1.1.3.5.0");
         switch ($MtaDevQosMode)
         {
             case 1: $this->MtaDevQosMode='dsxMode';
                 break;
             case 0: $this->MtaDevQosMode='bestEffort-FullDQos-PCMM';
                 break;
         }
         $a = $this->snmp_walk("1.3.6.1.4.1.4115.1.3.3.1.1.1.2.46.1.12");
         $k=1;
         for (reset($a); $i = key($a); next($a))
         {
            $line=str_replace($this->zastap,"",$a[$i]);
            switch ($line)
            {
                case 80: $this->MtaDevCallStatsLineSubState[]="Mta Call Stats Line SubState port $k: ".'normal';
                    break;
                case 81: $this->MtaDevCallStatsLineSubState[]="Mta Call Stats Line SubState port $k: ".'diagsPending';
                    break;                
                case 82: $this->MtaDevCallStatsLineSubState[]="Mta Call Stats Line SubState port $k: ".'diagsFailed';
                    break;                
                case 83: $this->MtaDevCallStatsLineSubState[]="Mta Call Stats Line SubState port $k: ".'lcProtection';
                    break;                
                case 84: $this->MtaDevCallStatsLineSubState[]="Mta Call Stats Line SubState port $k: ".'dspFail';
                    break;                                
            }
            $k++;
         }         

         $a = $this->snmp_walk("1.3.6.1.4.1.4115.1.3.3.1.1.1.2.46.1.11");
         $k=1;
         for (reset($a); $i = key($a); next($a))
         {
            $line=str_replace($this->zastap,"",$a[$i]);
            switch ($line)
            {
                case 1: $this->MtaDevCallStatsEndPntOpStatus[]="Mta Call Stats End Point OpStatus $k: ".'up';
                    break;
                case 2: $this->MtaDevCallStatsEndPntOpStatus[]="Mta Call Stats End Point OpStatus $k: ".'down';
                    break;
                case 3: $this->MtaDevCallStatsEndPntOpStatus[]="Mta Call Stats End Point OpStatus $k: ".'testing';
                    break;                
            }            
            $k++;
         }         
         $ProvisioningStatusLastUpdate=$this->snmp_get("1.3.6.1.4.1.4491.2.1.14.1.1.1.1.6.16");
         list($year1,$year2,$mounth,$day,$hour,$min,$sec,$msec)=split(' ',trim($ProvisioningStatusLastUpdate));
         $this->ProvisioningStatusLastUpdate=hexdec($year1.$year2).'-'.hexdec($mounth).'-'.hexdec($day).' '.hexdec($hour).':'.hexdec($min).':'.hexdec($sec).'.'.hexdec($msec);
                
         $DevProvState=$this->snmp_get("1.3.6.1.4.1.4115.1.3.3.1.1.1.2.4.0");   #arrisMtaDevProvState
         switch ($DevProvState)
         {
            case 1: $this->MtaDevProvState= "dhcpBound";
                break;
            case 2: $this->MtaDevProvState= "dnsReqProvSvrIP";
                break;
            case 3: $this->MtaDevProvState= "kdcHostNameDnsReq";
                break;
            case 4: $this->MtaDevProvState= "kdcHostNameDnsRply";
                break;
            case 5: $this->MtaDevProvState= "kdcIpDnsReq";
                break;
            case 6: $this->MtaDevProvState= "kdcIpDnsRply";
                break;
            case 7: $this->MtaDevProvState= "asReqSent";
                break;
            case 8: $this->MtaDevProvState= "asRplyRcvd";
                break;
            case 9: $this->MtaDevProvState= "tgsReqSent";
                break;
            case 10: $this->MtaDevProvState="tgsRplyRcvd";
                break;
            case 11: $this->MtaDevProvState="apReqSent";
                break;
            case 12: $this->MtaDevProvState="apRplyRcvd";
                break;
            case 13: $this->MtaDevProvState="enrollmentInform";
                break;
            case 14: $this->MtaDevProvState="cfgUrlSet";
                break;
            case 15: $this->MtaDevProvState="dnsReqTftpSvrIp";
                break;
            case 16: $this->MtaDevProvState="cfgFileReq";
                break;
            case 17: $this->MtaDevProvState="rcvCfgFile";
                break;            
            case 18: $this->MtaDevProvState="syslogMsgProvComplete";
                break;            
            case 19: $this->MtaDevProvState="statusInform";
                break;            
            case 20: $this->MtaDevProvState="provcomplete";
                break;            
            default: $this->MtaDevProvState=$DevProvState;
         }
         
         $last_ids=$this->snmp_get("1.3.6.1.4.1.4115.1.3.3.1.1.1.4.4.1.2.1");         #last call IDS
         $ret=$this->snmp_set("1.3.6.1.4.1.4115.1.3.3.1.1.1.4.5.0", $last_ids, "integer");   #set for read VQM table for last IDS
         $this->vqm="";
         $this->vqm2="";
         if ($ret)
         {    
            $a = $this->snmp_walk("1.3.6.1.4.1.4115.1.3.3.1.1.1.4.6.1.2");
            $k=count($a);
            for (reset($a); $i = key($a); next($a))
            {
                $tmp[]=str_replace($this->zastap,"",$a[$i]);
            }
            for($i=0;$i<=22;$i++)
            {
                list($desc,$value)=split(":",$tmp[$i]);
                $this->vqm_description[]=$desc;
                $this->vqm[]=            $value;
            }
            for ($i=23;$i<=44;$i++)
            {
                list($desc,$value)=split(":",$tmp[$i]);
                $this->vqm2_description[]=$desc;
                $this->vqm2[]=            $value;
            }            
            for ($i=45;$i<=66;$i++)
            {
                list($desc,$value)=split(":",$tmp[$i]);
                $this->vqm3_description[]=$desc;
                $this->vqm3[]=            $value;
            }                        
         } else 
            {
                $this->vqm_description[]='Not available or for only Arris modems';
                $this->vqm[]='Not available or for only Arris modems';
            }
      }


      function show_tpl()
      {
         require('libs/Smarty.class.php');
         $tpl = new Smarty;
         $tpl -> template_dir = './';
         $tpl -> compile_dir = './templates_c/';

         $tpl -> assign('ip',          $this->ip_address);
         $tpl -> assign('systems',     $this->system);
         $tpl -> assign('model',       $this->model);
         $tpl -> assign('vendor',      $this->vendor);
         $tpl -> assign('location',    $this->location);
         $tpl -> assign('names',       $this->name);
         $tpl -> assign('is_autocheck',$this->is_auto_check);

         $tpl -> assign('downstream_frequency',     $this->downstream_frequency);
         $tpl -> assign('downstream_annex',         $this->downstream_annex);
         $tpl -> assign('downstream_chan_id',       $this->downstream_chan_id);
         $tpl -> assign('downstream_chan_opis',     $this->downstream_chan_opis);
         $tpl -> assign('downstream_sn',            $this->downstream_sn);
         $tpl -> assign('downstream_microref',      $this->downstream_microref);
         $tpl -> assign('downstream_power',         $this->downstream_power);
         $tpl -> assign('downstream_modulation',    $this->downstream_modulation);
         $tpl -> assign('downstream_bandwidth',     $this->downstream_bandwidth);         
         $tpl -> assign('downstream_code_feccorr',  $this->downstream_code_feccorr);
         $tpl -> assign('downstream_code_fecuncorr',$this->downstream_code_fecuncorr);
         $tpl -> assign('downstream_traffic',       $this->downstream_traffic);
         $tpl -> assign('downstream_code_unerror',  $this->downstream_code_unerror);
         $tpl -> assign('downstream_code_correct',  $this->downstream_code_correct);
         $tpl -> assign('downstream_code_uncorrect',$this->downstream_code_uncorrect);

         $tpl -> assign('upstream_frequency',     $this->upstream_frequency);
         $tpl -> assign('upstream_chan_id',       $this->upstream_chan_id);
         $tpl -> assign('upstream_modulation',    $this->upstream_modulation);
         $tpl -> assign('upstream_tx_power',      $this->upstream_tx_power);
         $tpl -> assign('upstream_rx_power',      $this->upstream_rx_power);
         $tpl -> assign('upstream_sn',            $this->upstream_sn);
         $tpl -> assign('upstream_bandwidth',     $this->upstream_bandwidth);
         $tpl -> assign('upstream_code_feccorr',  $this->upstream_code_feccorr);
         $tpl -> assign('upstream_code_fecuncorr',$this->upstream_code_fecuncorr);
         $tpl -> assign('upstream_traffic',       $this->upstream_traffic);
         $tpl -> assign('upstream_code_unerror',  $this->upstream_code_unerror);
         $tpl -> assign('upstream_code_correct',  $this->upstream_code_correct);
         $tpl -> assign('upstream_code_uncorrect',$this->upstream_code_uncorrect);

         $tpl -> assign('other_t1',         $this->other_t1);
         $tpl -> assign('other_t2',         $this->other_t2);
         $tpl -> assign('other_t3',         $this->other_t3);
         $tpl -> assign('other_t4',         $this->other_t4);
         $tpl -> assign('other_dhcp_ip',    $this->other_dhcp_ip);
         $tpl -> assign('other_docsis_ver', $this->other_docsis_ver);
         $tpl -> assign('other_tod_ip',     $this->other_tod_ip);
         $tpl -> assign('other_tftp_ip',    $this->other_tftp_ip);
         $tpl -> assign('other_hfc_mac',    $this->other_hfc_mac);
         $tpl -> assign('other_eth_mac',    $this->other_eth_mac);
         $tpl -> assign('other_usb_mac',    $this->other_usb_mac);
         $tpl -> assign('other_eth_ip',     $this->other_eth_ip);
         $tpl -> assign('other_cm_model',   $this->other_cm_model);
         $tpl -> assign('other_cm_serial',  $this->other_cm_serial);
         $tpl -> assign('other_cm_uptime',  $this->other_cm_uptime);
         $tpl -> assign('other_cm_restart', $this->other_cm_restart);
         $tpl -> assign('other_config_file',$this->other_config_file);
         $tpl -> assign('other_soft_ver',   $this->other_soft_ver);
         $tpl -> assign('other_soft_file',  $this->other_soft_file);
         $tpl -> assign('other_hw_ver',     $this->other_hw_ver);
         $tpl -> assign('other_mta_file',   $this->other_mta_file);
         $tpl -> assign('other_mta_ip',     $this->other_mta_ip);
         $tpl -> assign('other_cm_ip_mask', $this->other_cm_ip_mask);
         $tpl -> assign('other_cm_ip_gateway', $this->other_cm_ip_gateway);

         $tpl -> assign('cm_state',                           $this->cm_state);
         $tpl -> assign('cm_state_cmts',                      $this->cm_state_cmts);
         $tpl -> assign('cm_state_cmts_cisco',                $this->cm_state_cmts_cisco);
         $tpl -> assign('cmts_mac_domain',                    $this->cmts_mac_domain);
         $tpl -> assign('cmts_mac_domain_description',        $this->cmts_mac_domain_description);
         $tpl -> assign('cmts_mac_domain_interface_mtu',      $this->cmts_mac_domain_interface_mtu);
         $tpl -> assign('cmts_mac_domain_interface_adm_stat', $this->cmts_mac_domain_interface_adm_stat);
         $tpl -> assign('cmts_mac_domain_interface_oper_stat',$this->cmts_mac_domain_interface_oper_stat);
         $tpl -> assign('cmts_mac_domain_in_traffic',         $this->cmts_mac_domain_in_traffic);
         $tpl -> assign('cmts_mac_domain_out_traffic',        $this->cmts_mac_domain_out_traffic);
         $tpl -> assign('cmts_mac_domain_in_errors',          $this->cmts_mac_domain_in_errors);
         $tpl -> assign('cmts_mac_domain_out_errors',         $this->cmts_mac_domain_out_errors);         
         
         $tpl -> assign('lp',        $this->lp);
         $tpl -> assign('mac_cpe',   $this->mac_cpe);
         $tpl -> assign('ip_cpe',    $this->ip_cpe);
         $tpl -> assign('state_cpe', $this->state_cpe);

         $tpl -> assign('sfid',$this->sfid);
         $tpl -> assign('docsQosServiceFlowSID',             $this->docsQosServiceFlowSID);
         $tpl -> assign('docsQosServiceFlowDirection',       $this->docsQosServiceFlowDirection);
         $tpl -> assign('docsQosServiceFlowPrimary',         $this->docsQosServiceFlowPrimary);
         $tpl -> assign('docsQosServiceFlowPkts',            $this->docsQosServiceFlowPkts);
         $tpl -> assign('docsQosServiceFlowOctets',          $this->docsQosServiceFlowOctets);
         $tpl -> assign('docsQosServiceFlowPolicedDropPkts', $this->docsQosServiceFlowPolicedDropPkts);
         $tpl -> assign('docsQosServiceFlowPolicedDelayPkts',$this->docsQosServiceFlowPolicedDelayPkts);
         $tpl -> assign('docsQosServiceFlowTimeActive',      $this->docsQosServiceFlowTimeActive);

         $tpl -> assign('docsQosPktClassState',              $this->docsQosPktClassState);
         $tpl -> assign('docsQosParamSetMaxTrafficRate',     $this->docsQosParamSetMaxTrafficRate);
         $tpl -> assign('docsQosParamSetMaxTrafficBurst',    $this->docsQosParamSetMaxTrafficBurst);
         $tpl -> assign('docsQosParamSetMinReservedRate',    $this->docsQosParamSetMinReservedRate);
         $tpl -> assign('docsQosParamSetMinReservedPkt',     $this->docsQosParamSetMinReservedPkt);
         $tpl -> assign('docsQosParamSetSchedulingType',     $this->docsQosParamSetSchedulingType);

         $tpl -> assign('docsis_ver',   $this->other_docsis_ver);
         $tpl -> assign('dss3_opis',    $this->dss3_opis);
         $tpl -> assign('dss3_fr',      $this->dss3_fr);
         $tpl -> assign('dss3_admin_st',$this->dss3_admin_st);
         $tpl -> assign('dss3_oper_st', $this->dss3_oper_st);
         $tpl -> assign('dss3_power',   $this->dss3_power);
         $tpl -> assign('dss3_sn',      $this->dss3_sn);
         $tpl -> assign('dss3_uner',    $this->dss3_uner);
         $tpl -> assign('dss3_cor',     $this->dss3_cor);
         $tpl -> assign('dss3_uncor',   $this->dss3_uncor);
         $tpl -> assign('dss3_microref',$this->dss3_microref);

         $tpl -> assign('uss3_opis',    $this->uss3_opis);
         $tpl -> assign('uss3_fr',      $this->uss3_fr);
         $tpl -> assign('uss3_admin_st',$this->uss3_admin_st);
         $tpl -> assign('uss3_oper_st', $this->uss3_oper_st);
         $tpl -> assign('uss3_power',   $this->uss3_power);
         $tpl -> assign('uss3_chan_id', $this->uss3_chan_id);
         $tpl -> assign('uss3_bandwith',$this->uss3_bandwith);

         $tpl -> assign('usb_status',  $this->usb_status);
         $tpl -> assign('usb_admin_st',$this->usb_admin_st);
         $tpl -> assign('usb_oper_st', $this->usb_oper_st);
         $tpl -> assign('eth_admin_st',$this->eth_admin_st);
         $tpl -> assign('eth_oper_st', $this->eth_oper_st);

         $tpl -> assign('mta_lines',   $this->mta_lines);
         $tpl -> assign('vqm',         $this->vqm);
         $tpl -> assign('vqm2',        $this->vqm2);
         $tpl -> assign('vqm3',        $this->vqm3);
         $tpl -> assign('vqm_description', $this->vqm_description);
         $tpl -> assign('vqm2_description',$this->vqm2_description);
         $tpl -> assign('vqm3_description',$this->vqm3_description);         
         $tpl -> assign('MtaDevProvState', $this->MtaDevProvState);
         $tpl -> assign('MtaDevQosMode',                $this->MtaDevQosMode);
         $tpl -> assign('MtaDevCallStatsEndPntOpStatus',$this->MtaDevCallStatsEndPntOpStatus);
         $tpl -> assign('MtaDevCallStatsLineSubState',  $this->MtaDevCallStatsLineSubState);         
         $tpl -> assign('ProvisioningStatusLastUpdate', $this->ProvisioningStatusLastUpdate);
         
         $tpl -> assign('refresh_interval',$this->refresh_interval);
         
         if($this->tpl_file=="")    $this->tpl_file='templates/cmwatch.tpl';
         if($this->tpl_toolbar=="") $this->tpl_file='templates/cmwatch_toolbar.tpl';                
         $tpl -> display($this->tpl_toolbar);                  
         $tpl -> display($this->tpl_file);

      }

      function check_modem()
      {
         $_SESSION["autorefresh"]=0;
         $ping=1;
                           
         if (!(trim($this->ip_address) == ""))
         {
            $_SESSION["autorefresh"]=1;
            $ping=$this->ping();
         }
         $this->s_ping="";
         if ( $ping == 0 )
         {
               $this->system=  $this->snmp_get("1.3.6.1.2.1.1.1.0");               
               $this->location=$this->snmp_get("1.3.6.1.2.1.1.6.0");
               $this->name=    $this->snmp_get("1.3.6.1.2.1.1.5.0");
               
               $this->check_vendor();
               $this->downstream_check();
               $this->upstream_check();
               $this->other_check();               
               $this->standby_check();

               $this->docsis3_check_downstream();
               $this->docsis3_check_upstream();
               switch (strtoupper($this->cmts_vendor))
               {
                   case "ARRIS": $this->cpe_check_arris();
                       break;
                   case "CISCO": $this->cpe_check_cisco();
                       break;
                   default:      $this->cpe_check_cm();
               }
               //$this->show_cmts();
               $this->show_mta();
         } else $this->cm_state='<a href="#" >'."<font color='#FF0000'><b>Modem not response</b></font></a>";
         $this->show_cmts();
         $this->check_is_auto_check();
         //$this->set_tpl();
      }
      
      function save_to_txt()
      {
         $ping=1;
         if (!(trim($this->ip_address) == ""))
         {
            $ping=$this->ping();
         }
         if ( $ping == 0 )
         {
            if ( trim($this->ip_address) != '' )
            {
               $this->system=  $this->snmp_get("1.3.6.1.2.1.1.1.0");               
               $this->location=$this->snmp_get("1.3.6.1.2.1.1.6.0");
               $this->name=    $this->snmp_get("1.3.6.1.2.1.1.5.0");
               
               $this->check_vendor();
               $this->downstream_check();
               $this->upstream_check();
               $this->other_check();
               $this->standby_check();

               $this->docsis3_check_downstream();
               $this->docsis3_check_upstream();
               switch (strtoupper($this->cmts_vendor))
               {
                   case "ARRIS": $this->cpe_check_arris();
                       break;
                   case "CISCO": $this->cpe_check_cisco();
                       break;
                   default:      $this->cpe_check_cm();
               }
               $this->show_cmts();
               $this->show_mta();
            }            
         }
         $this->set_tpl_save_to_txt();
      }
      
      function set_tpl_save_to_txt()
      {
         require('libs/Smarty.class.php');
         $tpl_txt = new Smarty;
         $tpl_txt -> template_dir = './';
         $tpl_txt -> compile_dir = './templates_c/';

         $tpl_txt -> assign('ip',      $this->ip_address);
         $tpl_txt -> assign('systems', $this->system);
         $tpl_txt -> assign('location',$this->location);
         $tpl_txt -> assign('names',   $this->name);

         $tpl_txt -> assign('downstream_frequency',     $this->downstream_frequency);
         $tpl_txt -> assign('downstream_chan_id',       $this->downstream_chan_id);
         $tpl_txt -> assign('downstream_chan_opis',     $this->downstream_chan_opis);
         $tpl_txt -> assign('downstream_sn',            $this->downstream_sn);
         $tpl_txt -> assign('downstream_microref',      $this->downstream_microref);
         $tpl_txt -> assign('downstream_power',         $this->downstream_power);
         $tpl_txt -> assign('downstream_modulation',    $this->downstream_modulation);
         $tpl_txt -> assign('downstream_bandwidth',     $this->downstream_bandwidth);
         $tpl_txt -> assign('downstream_code_feccorr',  $this->downstream_code_feccorr);
         $tpl_txt -> assign('downstream_code_fecuncorr',$this->downstream_code_fecuncorr);
         $tpl_txt -> assign('downstream_traffic',       $this->downstream_traffic);
         $tpl_txt -> assign('downstream_code_unerror',  $this->downstream_code_unerror);
         $tpl_txt -> assign('downstream_code_correct',  $this->downstream_code_correct);
         $tpl_txt -> assign('downstream_code_uncorrect',$this->downstream_code_uncorrect);

         $tpl_txt -> assign('upstream_frequency',     $this->upstream_frequency);
         $tpl_txt -> assign('upstream_chan_id',       $this->upstream_chan_id);
         $tpl_txt -> assign('upstream_modulation',    $this->upstream_modulation);
         $tpl_txt -> assign('upstream_tx_power',      $this->upstream_tx_power);
         $tpl_txt -> assign('upstream_rx_power',      $this->upstream_rx_power);
         $tpl_txt -> assign('upstream_sn',            $this->upstream_sn);
         $tpl_txt -> assign('upstream_bandwidth',     $this->upstream_bandwidth);
         $tpl_txt -> assign('upstream_code_feccorr',  $this->upstream_code_feccorr);
         $tpl_txt -> assign('upstream_code_fecuncorr',$this->upstream_code_fecuncorr);
         $tpl_txt -> assign('upstream_traffic',       $this->upstream_traffic);
         $tpl_txt -> assign('upstream_code_unerror',  $this->upstream_code_unerror);
         $tpl_txt -> assign('upstream_code_correct',  $this->upstream_code_correct);
         $tpl_txt -> assign('upstream_code_uncorrect',$this->upstream_code_uncorrect);

         $tpl_txt -> assign('other_t1',         $this->other_t1);
         $tpl_txt -> assign('other_t2',         $this->other_t2);
         $tpl_txt -> assign('other_t3',         $this->other_t3);
         $tpl_txt -> assign('other_t4',         $this->other_t4);
         $tpl_txt -> assign('other_dhcp_ip',    $this->other_dhcp_ip);
         $tpl_txt -> assign('other_docsis_ver', $this->other_docsis_ver);
         $tpl_txt -> assign('other_tod_ip',     $this->other_tod_ip);
         $tpl_txt -> assign('other_tftp_ip',    $this->other_tftp_ip);
         $tpl_txt -> assign('other_hfc_mac',    $this->other_hfc_mac);
         $tpl_txt -> assign('other_eth_mac',    $this->other_eth_mac);
         $tpl_txt -> assign('other_usb_mac',    $this->other_usb_mac);
         $tpl_txt -> assign('other_eth_ip',     $this->other_eth_ip);
         $tpl_txt -> assign('other_cm_model',   $this->other_cm_model);
         $tpl_txt -> assign('other_cm_serial',  $this->other_cm_serial);
         $tpl_txt -> assign('other_cm_uptime',  $this->other_cm_uptime);
         $tpl_txt -> assign('other_cm_restart', $this->other_cm_restart);
         $tpl_txt -> assign('other_config_file',$this->other_config_file);
         $tpl_txt -> assign('other_soft_ver',   $this->other_soft_ver);
         $tpl_txt -> assign('other_soft_file',  $this->other_soft_file);
         $tpl_txt -> assign('other_hw_ver',     $this->other_hw_ver);
         $tpl_txt -> assign('other_mta_file',   $this->other_mta_file);
         $tpl_txt -> assign('other_mta_ip',     $this->other_mta_ip);

         $tpl_txt -> display('templates/save_to_txt.tpl');
      }            
   }
?>
