<?php

/**
 * @package         CMWatch server
 * @copyright       Copyright (C) 2012 Mariusz Dziewulski. All rights reserved.
 * @license         see LICENSE.txt
 * CMWatch server is free software only for non commercial use.
 */

#Read only snmp community for cable modem
$community_ro = "batius474";

#Read/Write snmp community for cable modem
#Used to set snmp objects
$community_rw = "BATIUS474";

#IP of CMTS
#Empty if ip cmts read from cm like gateway (auto)
$cmts_ip = '';
#Read only snmp community for CMTS
$cmts_ro_community = "dcva11mz";
#Read/Write snmp community for CMTS
$cmts_rw_community = "";
#Vendor of CMTS
#In this version only Cisco and Arris or empty
#empty for read from cable modem
#$cmts_vendor="Arris";
#$cmts_vendor="";
$cmts_vendor="Cisco";

#Login and password to CMTS console
$cmts_login="serwis";
$cmts_password="serwis123";

#Refresh interval for refreshing monitoring page
$refresh_interval = "5";

#Read CM list from CMTS with location (1) or not (0)
$read_cm_from_cmts_with_location=0;

$ROOTPATH="..";
$TMP=$ROOTPATH."/tmp/";
$RRDBIN="/usr/bin"; 
$rrdpath=$ROOTPATH."/rrd/";

#Map cable modem Vendors
$cm_vendors = array(
    '00:1F:C4'=>'Motorola',
    '00:11:E6'=>'SA',
    '00:11:F5'=>'Askey',
    '00:0A:06'=>'Teledex',
    '00:D0:DD'=>'Sunrise',
    '00:08:0D'=>'Toshiba',
    '00:08:0E'=>'Motorola',
    '00:E0:CA'=>'BestData',
    '00:0E:09'=>'COSHIP',
    '00:14:04'=>'Motorola',
    '02:60:8C'=>'3Com',
    '00:23:ED'=>'Motorola',
    '00:06:25'=>'Linksys',
    '00:10:18'=>'Broadcom',
    '00:12:17'=>'Cisco',
    '08:00:23'=>'Panasonic',
    '00:00:39'=>'Toshiba',
    '08:00:28'=>'TI',
    '00:12:25'=>'Motorola',
    '00:20:1B'=>'Nortel',
    '08:00:3E'=>'Motorola',
    '00:0C:41'=>'Linksys',
    '00:10:3F'=>'Tollgrade',
    '00:10:45'=>'Nortel',
    '00:40:01'=>'ZyXel',
    '00:02:5F'=>'Nortel',
    '00:10:4B'=>'3Com',
    '00:04:62'=>'DAKOS',
    '00:20:40'=>'Motorola',
    '00:12:55'=>'Motorola',
    '00:0E:5C'=>'Motorola',
    '00:04:75'=>'3Com',
    '00:50:04'=>'3Com',
    '00:0A:73'=>'SA',
    '00:30:3B'=>'PowerCom',
    '00:30:3F'=>'TurboComm',
    '00:30:41'=>'Saejin',
    '00:14:6C'=>'Netgear',
    '00:02:8A'=>'Ambit',
    '00:40:36'=>'Zoom',
    '00:08:8C'=>'QNS',
    '00:60:08'=>'3Com',
    '00:30:54'=>'Castlenet',
    '00:0E:90'=>'Ponico',
    '00:10:95'=>'RCA/Thomso',
    '00:0E:9B'=>'Ambit',
    '00:16:92'=>'SA',
    '00:02:B3'=>'Intel',
    '00:04:BD'=>'Motorola',
    '00:60:38'=>'Nortel',
    '00:30:80'=>'Cisco',
    '00:00:CA'=>'Arris',
    '00:50:57'=>'BAS',
    '00:02:CF'=>'ZyXel',
    '00:40:7B'=>'SA',
    '00:14:BF'=>'Linksys',
    '00:20:AF'=>'3Com',
    '00:12:C9'=>'Motorola',
    '00:04:E2'=>'SMC',
    '00:1A:C3'=>'SA',
    '00:00:F0'=>'Samsung',
    '00:0C:E5'=>'Motorola',
    '00:80:37'=>'Ericsson',
    '00:30:B8'=>'RiverDelta',
    '00:02:FD'=>'Cisco',
    '00:02:FE'=>'Infinite',
    '00:01:02'=>'3Com',
    '00:01:03'=>'3Com',
    '00:14:E8'=>'Motorola',
    '00:03:04'=>'Pacific',
    '00:20:D9'=>'Panasonic',
    '00:50:94'=>'Pace',
    '00:30:C8'=>'GADline',
    '00:A0:24'=>'3Com',
    '00:0B:06'=>'Motorola',
    '00:30:CD'=>'Conexant',
    '00:07:0E'=>'Cisco',
    '00:30:D0'=>'Tellabs',
    '00:11:04'=>'Telexy',
    '00:0F:12'=>'Panasonic',
    '00:13:10'=>'Linksys',
    '00:13:11'=>'Arris',
    '00:50:BA'=>'PowerCom',
    '00:11:1A'=>'Motorola',
    '00:30:EB'=>'TurboComm',
    '00:0F:21'=>'SA',
    '00:30:F1'=>'SMC',
    '00:90:64'=>'RCA/Thomso',
    '00:50:C9'=>'Maspro',
    '00:01:42'=>'Cisco',
    '00:A0:57'=>'Elsa',
    '00:11:2F'=>'ASUSTek',
    '00:07:3F'=>'Woojyun',
    '00:50:D4'=>'Joohong',
    '00:15:2F'=>'Motorola',
    '00:0F:3D'=>'D-Link',
    '00:50:DA'=>'3Com',
    '00:01:57'=>'Syswave',
    '00:90:83'=>'Toshiba',
    '00:03:58'=>'iCable_Sys',
    '00:E0:0C'=>'Motorola',
    '00:01:5C'=>'Cadant',
    '00:A0:73'=>'Com21',
    '00:25:2E'=>'Cisco',
    '00:01:64'=>'Cisco',
    '00:90:8E'=>'Nortel',
    '00:09:5B'=>'Netgear',
    '00:E0:18'=>'ASUSTek',
    '00:C0:49'=>'USRobotics',
    '00:50:F1'=>'TI',
    '00:19:47'=>'SA',
    '00:B0:64'=>'Cisco',
    '00:03:6B'=>'Cisco',
    '00:90:96'=>'Askey',
    '00:07:6C'=>'Daehanet',
    '00:0F:66'=>'Linksys',
    '00:03:78'=>'Humax',
    '00:01:81'=>'Nortel',
    '00:E0:36'=>'Pioneer',
    '00:80:C8'=>'D-Link',
    '00:13:71'=>'Motorola',
    '00:D0:58'=>'Cisco',
    '00:D0:59'=>'Ambit',
    '00:05:8C'=>'Opentech',
    '00:D0:5C'=>'Technotren',
    '00:C0:77'=>'Mercury',
    '00:D0:60'=>'Panasonic',
    '00:11:80'=>'Motorola',
    '00:0D:88'=>'D-Link',
    '00:90:CF'=>'Nortel',
    '00:90:D1'=>'Leichu',
    '00:80:F0'=>'Panasonic',
    '00:0F:9F'=>'Motorola',
    '00:15:96'=>'Arris',
    '00:A0:C5'=>'ZyXel',
    '00:01:B6'=>'Saejin',
    '00:E0:6F'=>'Terayon',
    '00:15:A2'=>'Arris',
    '00:15:A3'=>'Arris',
    '00:15:A4'=>'Arris',
    '00:11:AE'=>'Motorola',
    '00:0F:B5'=>'Netgear',
    '00:01:CB'=>'Coresma',
    '00:05:CA'=>'TriGem',
    '00:C0:B1'=>'GeniusNet',
    '00:E2:80'=>'TurboComm',
    '00:0B:C9'=>'Electrolin',
    '00:E0:91'=>'LG',
    '00:03:E3'=>'Cisco',
    '60:2A:D0'=>'Cisco',
    '00:01:EC'=>'Ericsson',
    '00:15:CE'=>'Arris',
    '00:15:CF'=>'Arris',
    '00:15:D0'=>'Arris',
    '00:15:D1'=>'Arris',
    '00:11:D8'=>'ASUSTek',
    '00:07:E9'=>'Intel',
    '00:E0:A6'=>'Telogy',
    '00:1D:CD'=>'Arris',
    '00:11:E3'=>'RCA/Thomso',
    '00:24:D1'=>'Thomson'
);


#Map table downstream ID to downstream name for CISCO uBR 10012 with UBR-MC3GX60V cable cards
$downstream_id = array(
    1 => "Mo5/0/0:0",
    2 => "Mo5/0/0:1",
    3 => "Mo5/0/0:2",
    4 => "Mo5/0/0:3",
    5 => "Mo5/0/0:4 Cable5/0/0",
    6 => "Mo5/0/0:5 Cable5/0/0",
    7 => "Mo5/0/0:6 Cable5/0/1",
    8 => "Mo5/0/0:7 Cable5/0/1",
    9 => "Mo5/0/0:8",
    10 => "Mo5/0/0:9",
    11 => "Mo5/0/0:10",
    12 => "Mo5/0/0:11",
    13 => "Mo5/0/0:12 Cable5/0/3",
    14 => "Mo5/0/0:13 Cable5/0/3",
    15 => "Mo5/0/0:14",
    16 => "Mo5/0/0:15",
    17 => "Mo5/0/0:16",
    18 => "Mo5/0/0:17",
    19 => "Mo5/0/0:18",
    20 => "Mo5/0/0:19 Cable5/0/8",
    21 => "Mo5/0/0:20 Cable5/0/8",
    22 => "Mo5/0/0:21",
    23 => "Mo5/0/0:22",
    24 => "Mo5/0/0:23",
    25 => "Mo5/0/0:24",
    26 => "Mo5/0/0:25",
    27 => "Mo5/0/0:26",
    28 => "Mo5/0/0:27",
    29 => "Mo5/0/0:28",
    30 => "Mo5/0/0:29",
    31 => "Mo5/0/0:30",
    32 => "Mo5/0/0:31",
    33 => "Mo5/0/0:32",
    34 => "Mo5/0/0:33",
    35 => "Mo5/0/0:34",
    36 => "Mo5/0/0:35",
    37 => "Mo5/0/0:36",
    38 => "Mo5/0/0:37",
    39 => "Mo5/0/0:38",
    40 => "Mo5/0/0:39",
    41 => "Mo5/0/0:40",
    42 => "Mo5/0/0:41",
    43 => "Mo5/0/0:42",
    44 => "Mo5/0/0:43",
    45 => "Mo5/0/0:44",
    46 => "Mo5/0/0:45",
    47 => "Mo5/0/0:46",
    48 => "Mo5/0/0:47",
    49 => "Mo5/0/0:48",
    50 => "Mo5/0/0:49",
    51 => "Mo5/0/0:50",
    52 => "Mo5/0/0:51",
    53 => "Mo5/0/0:52",
    54 => "Mo5/0/0:53",
    55 => "Mo5/0/0:54",
    56 => "Mo5/0/0:55",
    57 => "Mo5/0/0:56",
    58 => "Mo5/0/0:57",
    59 => "Mo5/0/0:58",
    60 => "Mo5/0/0:59",
    61 => "Mo5/0/0:60",
    62 => "Mo5/0/0:61",
    63 => "Mo5/0/0:62",
    64 => "Mo5/0/0:63",
    65 => "Mo5/0/0:64",
    66 => "Mo5/0/0:65",
    67 => "Mo5/0/0:66",
    68 => "Mo5/0/0:67",
    69 => "Mo5/0/0:68",
    70 => "Mo5/0/0:69",
    71 => "Mo5/0/0:70",
    72 => "Mo5/0/0:71",
    73 => "Mo5/1/0:0",
    74 => "Mo5/1/0:1",
    75 => "Mo5/1/0:2",
    76 => "Mo5/1/0:3 Cable5/1/1",
    77 => "Mo5/1/0:4 Cable5/1/1",
    78 => "Mo5/1/0:5 Cable5/1/0",
    79 => "Mo5/1/0:6 Cable5/1/0",
    80 => "Mo5/1/0:7",
    81 => "Mo5/1/0:8",
    82 => "Mo5/1/0:9",
    83 => "Mo5/1/0:10",
    84 => "Mo5/1/0:11 Cable5/1/2",
    85 => "Mo5/1/0:12 Cable5/1/2",
    86 => "Mo5/1/0:13",
    87 => "Mo5/1/0:14",
    88 => "Mo5/1/0:15",
    89 => "Mo5/1/0:16",
    90 => "Mo5/1/0:17",
    91 => "Mo5/1/0:18",
    92 => "Mo5/1/0:19",
    93 => "Mo5/1/0:20",
    94 => "Mo5/1/0:21",
    95 => "Mo5/1/0:22",
    96 => "Mo5/1/0:23",
    97 => "Mo5/1/0:24",
    98 => "Mo5/0/0:25",
    99 => "Mo5/0/0:26",
    100 => "Mo5/0/0:27",
    101 => "Mo5/0/0:28",
    102 => "Mo5/0/0:29",
    103 => "Mo5/0/0:30",
    104 => "Mo5/0/0:31",
    105 => "Mo5/0/0:32",
    106 => "Mo5/0/0:33",
    107 => "Mo5/0/0:34",
    108 => "Mo5/0/0:35 Cable5/1/3",
    109 => "Mo5/0/0:36 Cable5/1/3",
    110 => "Mo5/0/0:37 Cable5/1/5",
    111 => "Mo5/0/0:38 Cable5/1/4",
    112 => "Mo5/0/0:39",
    113 => "Mo5/0/0:40",
    114 => "Mo5/0/0:41",
    115 => "Mo5/0/0:42",
    116 => "Mo5/0/0:43 Cable5/1/6",
    117 => "Mo5/0/0:44 Cable5/1/6",
    118 => "Mo5/0/0:45 Cable5/1/7",
    119 => "Mo5/0/0:46 Cable5/1/7",
    120 => "Mo5/0/0:47",
    121 => "Mo5/0/0:48",
    122 => "Mo5/0/0:49",
    123 => "Mo5/0/0:50",
    124 => "Mo5/0/0:51",
    125 => "Mo5/0/0:52",
    126 => "Mo5/0/0:53",
    127 => "Mo5/0/0:54",
    128 => "Mo5/0/0:55",
    129 => "Mo5/0/0:56",
    130 => "Mo5/0/0:57",
    131 => "Mo5/0/0:58",
    132 => "Mo5/0/0:59",
    133 => "Mo5/0/0:60",
    134 => "Mo5/0/0:61",
    135 => "Mo5/0/0:62",
    136 => "Mo5/0/0:63",
    137 => "Mo5/0/0:64",
    138 => "Mo5/0/0:65",
    139 => "Mo5/0/0:66",
    140 => "Mo5/0/0:67",
    141 => "Mo5/0/0:68",
    142 => "Mo5/0/0:69",
    143 => "Mo5/0/0:70",
    144 => "Mo5/0/0:71"
);
/*
  $downstream_id=array(
  33=>"0/0/",
  34=>"1/0/",
  35=>"2/0/",
  36=>"3/0/",
  37=>"4/0/",
  38=>"5/0/",
  39=>"6/0/",
  40=>"7/0/",
  41=>"8/0/",
  42=>"9/0/",
  43=>"10/0/",
  44=>"11/0/",
  45=>"12/0/",
  46=>"13/0/",
  47=>"14/0/",
  48=>"15/0/",
  65=>"0/1/",
  66=>"1/1/",
  67=>"2/1/",
  68=>"3/1/",
  69=>"4/1/",
  70=>"5/1/",
  71=>"6/1/",
  72=>"7/1/",
  73=>"8/1/",
  74=>"9/1/",
  75=>"10/1/",
  76=>"11/1/",
  77=>"12/1/",
  78=>"13/1/",
  79=>"14/1/",
  80=>"15/1/");
 */

    $replace = array("INTEGER:","IpAddress:","STRING:","HEX-:","Timeticks:","Hex-","Hex-STRING: ","<>","Counter32:",'"',"<",">","Gauge32:","ethernetCsmacd(6)","softwareLoopback(24)","other(1)");
?>
